<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2007
sirfragalot@users.sourceforge.net
**********************************************************************************/
/*****
*
* WIKINDX v3.x CONFIGURATION FILE
*
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
*
* If you make changes, backup the edited file as future upgrades of WIKINDX will write over this file - no questions asked!
*****/

/**********************************************************************************/

/*****
START DATABASE CONFIGURATION
*****/
// host on which the relational db management system (i.e. the MySQL server) is running (usually localhost if
// the web files are on the same server as the RDBMS)
// NB:
// The database and permissions for accessing it must be created using your RDBMS client. Wikindx
// will NOT do this for you.  If unsure how to do this, contact your server admin. After you have 
// set up an empty database with the correct permissions (GRANT ALL), the first running of Wikindx 
// will create the necessary database tables.
$WIKINDX_DB_HOST = "localhost";
// name of the database which these scripts interface with:
$WIKINDX_DB = "wikindx3";
// username and password required to connect to and open the database (it is strongly 
// recommended that you change these default values):
$WIKINDX_DB_USER = "wikindx";
$WIKINDX_DB_PASSWORD = "wikindx";
//This version only supports 'mysql' so do not change this.
$WIKINDX_DB_TYPE = "mysql";
// WIKINDX uses MySQL persistent connections by default.  Some hosting services are not configured for this: if you have problems 
// connecting to your MySQL server and/or receive error messages about 'too many connections', set $WIKINDX_DB_PERSISTENT to FALSE
$WIKINDX_DB_PERSISTENT = TRUE;
/*****
END DATABASE CONFIGURATION
*****/

/**********************************************************************************/

/*****
START AUTHORIZATION CONFIGURATION
*****/
// If $WIKINDX_DENY_READONLY is TRUE, read only access is denied and only logged on users can access the WIKINDX.
// (Although contrary to my philosophy of sharing knowledge, I've bowed to the inevitable pressure.)
$WIKINDX_DENY_READONLY = FALSE;
// If $WIKINDX_READONLYACCESS is TRUE, an initial attempt to access WIKINDX will automatically grant that user read only access if there is no 
// write access cookie set and $WIKINDX_DENY_READONLY is FALSE.  Setting this to FALSE, will present the user with the logon prompt.
$WIKINDX_READONLYACCESS = TRUE;
// If $WIKINDX_ORIGINATOR_EDITONLY is TRUE, only the originator of the bibliographic entry and the WIKINDX administrators may 
// edit it (other write-enabled users may still add metadata to the entry).  Otherwise, all write-enabled users may edit any bibliographic entry.
$WIKINDX_ORIGINATOR_EDITONLY = FALSE;
// If $WIKINDX_GLOBAL_EDIT is TRUE, all write-enabled users may use the Edit menu to globally edit creators, publishers, collections and keywords.  If 
// FALSE, only the admin may do this.
$WIKINDX_GLOBAL_EDIT = TRUE;
/*****
END AUTHORIZATION CONFIGURATION
*****/

/**********************************************************************************/

/******
START SESSION CONFIGURATION
******/
// On some web-hosting services, disk quotas are set on session storage directories.  WIKINDX is a heavy user of sessions and the folder set for storing session data may fill up 
// quickly causing session write errors.  This variable sets an alternate path for storing sessions (which can be in your home directory).  If this variable does not exist or has no 
// value, the default session  path, as set in php.ini, will be used.  If it exists and has a value, the directory must exist and be writable by the web server user.
// There should be no trailing '\' or '/'.
// Example for a windows system:
// $WIKINDX_SESSION_PATH = "D:\sessions";

// If $WIKINDX_SESSION_PATH is set, this value will remove sessions in that directory older than xx days.  Set to 0 to never remove sessions.
// The value will be ignored if $WIKINDX_SESSION_PATH does not exist or is empty.
$WIKINDX_SESSION_PATH_CLEAR = 10;
/******
ENDSESSION CONFIGURATION
******/

/**********************************************************************************/

/******
START DIRECTORY PATH CONFIGURATION
******/
// Alternate locations for storing SUWP papers, attachments and exported files.  If these do not exist or are commented out, the default locations at the 
// top level of wikindx3/ will be used.  It is the adminstrator's responsibility to ensure that these directories are web-server user readable and writeable.
// There should be no trailing '\' or '/'.
//$WIKINDX_PAPERS_DIR = "D:\papers";
//$WIKINDX_ATTACHMENTS_DIR = "D:\attachments";
//$WIKINDX_FILES_DIR = "D:\files";
/******
END DIRECTORY PATH CONFIGURATION
******/

/**********************************************************************************/

/*****
START ERROR and DEBUGGING CONFIGURATION
*****/
// Set the following to TRUE to turn on error reporting
$WIKINDX_ERROR_REPORTING = FALSE;
/*****
END ERROR and DEBUGGING CONFIGURATION
*****/

/**********************************************************************************/

/*****
START PHP MEMORY CONFIGURATION
*****/
// WIKINDX usually runs with the standard PHP memory_limit of 8MB.  With some PHP configurations, however, this is not enough -- a mysterious 
// blank page is often the result.  If you are unable to update php.ini's memory_limit yourself, $WIKINDX_MEMORY_LIMIT may be set (an integer 
// followed by 'M').  Despite the PHP manual stating that this may not be set outside of php.ini, it has been reported on the WIKINDX 
// sourceforge forum that it does work in some cases.  It is not, however, guaranteed to work and editing php.ini is the preferred method.
//$WIKINDX_MEMORY_LIMIT = "16M";
/*****
END PHP MEMORY CONFIGURATION
*****/

/**********************************************************************************/

/*****
START RESOURCE TYPE CONFIGURATION
*****/
// Deactivate resource types.  Simply uncomment those resource types that you wish to be disabled.
// Deactivated resource types that are already in the database will not have their display affected.
// The importing and exporting of bibliographies will ignore deactivated resource types in this list.
$WIKINDX_DEACTIVATE_RESOURCE_TYPES = array(
// 'book',
// 'book_article',
// 'journal_article',
// 'newspaper_article',
// 'magazine_article',
// 'proceedings',
// 'conference_paper',
// 'proceedings_article',
// 'thesis',
// 'web_article',
// 'film',
// 'broadcast',
// 'music_album',
// 'music_track',
// 'music_score',
// 'artwork',
// 'software',
// 'audiovisual',
// 'database',
// 'government_report',
// 'report',
// 'hearing',
// 'statute',
// 'legal_ruling',
// 'case',
// 'bill',
// 'patent',
// 'personal',
// 'unpublished',
// 'classical',
// 'manuscript',
// 'map',
// 'chart',
// 'miscellaneous',
// 'miscellaneous_section',
// 'web_site',
// 'book_chapter',
// 'web_encyclopedia',
// 'web_encyclopedia_article',
);
/*****
END RESOURCE TYPE CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  RSS CONFIGURATION (see rss.php)
*****/
// These are only required if you wish to run a RSS news feed for the latest additions to your WIKINDX.  See README_RSS.
// If $WIKINDX_RSS_ALLOW is FALSE, WIKINDX will block RSS access.
$WIKINDX_RSS_ALLOW = TRUE;
// No. of items to send to the feed.
$WIKINDX_RSS_LIMIT = 10;
// WIKINDX main address as a base for adding the resource view querystring.  This should be the full external hostname and path.
$WIKINDX_RSS_HOST = "http://localhost/wikindx3/index.php";
// Bibliographic style (UPPERCASE one of the directory names in wikindx3/styles/bibliography/)
$WIKINDX_RSS_BIBSTYLE = "APA";
// Set this to FALSE to display only recently added resources or to TRUE to display recently added AND edited resources.
$WIKINDX_RSS_DISPLAY = TRUE;
// RSS Title
$WIKINDX_RSS_TITLE = "WIKINDX";
// RSS Description
$WIKINDX_RSS_DESCRIPTION = "My Wikindx";
// RSS Language
$WIKINDX_RSS_LANGUAGE = "en";
/*****
END RSS CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  EMAIL CONFIGURATION
*****/
// In a multi-user WIKINDX, if $WIKINDX_READONLYACCESS is TRUE, an 'Email resource to friend' hyperlink is shown when 
// viewing a single resource.  This opens a pop-up window where the user can compose a message and email the resource ID to a friend.  This 
// relies on there being a mail server in php.ini.  If this is the case, and you wish to make this feature available, 
// set $WIKINDX_MAIL_SERVER to TRUE otherwise (or if in doubt) set it to FALSE.  Most web hosting services will have a mail 
// server that WIKINDX can use.
$WIKINDX_MAIL_SERVER = FALSE;
// If required, enter the 5th mail field here (the return path -- possibly something like '-f postmaster@domain.dom' including single-quotes).  Otherwise, or if unsure, 
// leave $WIKINDX_MAIL_RETURN_PATH as FALSE
// See Feature Request at:  http://sourceforge.net/tracker/index.php?func=detail&aid=1835467&group_id=94435&atid=607913
$WIKINDX_MAIL_RETURN_PATH = FALSE;
/*****
END EMAIL CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  CMS CONFIGURATION
*****/
// These are only required if you wish to use WIKINDX to print individual resources or lists directly to a Content Management System.  See README_CMS.
// If $WIKINDX_CMS_ALLOW is TRUE, any user, regardless of the access settings (see above) may use the WIKINDX CMS hooks as provided in 
// README_CMS to display WIKINDX content in their CMS.  If FALSE, WIKINDX will block access.
$WIKINDX_CMS_ALLOW = TRUE;
// Bibliographic style (UPPERCASE one of the directory names in wikindx3/styles/bibliography/)
$WIKINDX_CMS_BIBSTYLE = "APA";
/*****
END  CMS CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  TAG CLOUD CONFIGURATION
*****/
// When browsing tag clouds (for example, Browse Keywords in the Resources menu), you can indicate the frequency of the data by a range of  colours and 
// font sizes from low to high.
// Font colours should be given as a hexadecimal string without any leading '#' or '0x'.  Each pair of hexadecimal characters (using the characters 0-9 and a-f or A-F) 
// represents the amount of red, green and blue (RGB) in the final colour.  For example, 'ff0000' or 'FF0000' is bright red', '000000' is black (no colour), 'ffffff' is white 
//(all bright colours equally), '00ff00' is green and 'ff00ff' is purple (a mix of bright red and bright blue)..  Other colours and their hexadecimal equivalents may be 
// found here:  http://www.siteprocentral.com/html_color_code.html.
// Font sizes are given in em values.
// NB the background colour and the way the hyperlinks are displayed are given in the template's CSS file as the classes 'browseLink' and 'browseParagraph'
$WIKINDX_TAG_LOW_COLOUR = "f060f0";
$WIKINDX_TAG_HIGH_COLOUR = "ff0000";
$WIKINDX_TAG_LOW_SIZE = 0.8;
$WIKINDX_TAG_HIGH_SIZE = 1.5;
/*****
END  TAG CLOUD CONFIGURATION
*****/
?>
