<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2007
sirfragalot@users.sourceforge.net
**********************************************************************************/
/*****
*	Collection class.
*	A collection is a journal, edited book, CD etc. - something which has 
*	multiple resources within it.
*****/
class COLLECTION
{
// Constructor
	function COLLECTION($db, $vars = FALSE)
	{
		$this->db = $db;
		$this->vars = $vars;
		include_once("core/html/HTML.php");
		$this->html = new HTML();
		include_once("core/session/SESSION.php");
		$this->session = new SESSION();
		include_once("core/messages/MESSAGES.php");
		$this->messages = new MESSAGES();
		include_once("core/messages/SUCCESS.php");
		$this->success = new SUCCESS();
		include_once("core/messages/ERRORS.php");
		$this->errors = new ERRORS();
		include_once("core/collection/COLLECTIONMAP.php");
		$this->map = new COLLECTIONMAP();
		include_once("core/html/MISC.php");
		include_once("core/html/FORM.php");
		include_once("core/template/TEMPLATE.php");
		$this->template = new TEMPLATE('content');
		include_once("core/html/CLOSE.php");
		include_once("core/messages/UTF8.php");
		$this->utf8 = new UTF8();
		$this->dbCollections = array();
	}
// Get collection from WKX_collection.  Return associative array of id => collection
	function grabAll($type = FALSE, $userBib = FALSE)
	{
		if(!$userBib && !$type && is_array($collections = $this->db->readCache('resourceCollections')))
				return $collections;
		if($type)
			$condition[] = "(". $this->db->formatField('collectionType') . "=" . 
			$this->db->tidyInput($type) . ")";
		$thisType = $type;
		if($userBib)
		{
/*			$recordset = $this->db->select(array('WKX_user_bibliography'), array('bibliography'), 
				" WHERE " . $this->db->formatfield('id') . "=" . $this->db->tidyInput($userBib));
			$dbBibs = $this->db->fetchOne($recordset);
			$bibsArray = explode(",", $dbBibs);
			foreach($bibsArray as $resourceId)
				$bibConditionArray[] = $this->db->tidyInput($resourceId);
			$condition[] = " (WKX_resource_misc.id = " . 
				implode(" OR WKX_resource_misc.id = ", $bibConditionArray) . ")";
*/
			$condition[] = " FIND_IN_SET(" . $this->db->formatField('WKX_resource_misc.id') . 
				", CONCAT(" . $this->db->formatField('WKX_user_bibliography.bibliography') . 
				", ','))";
			$condition[] = $this->db->formatField('WKX_user_bibliography.id') . "=" . 
				$this->db->tidyInput($userBib);
			$sql = $this->db->selectNoExecute(array('WKX_collection', 'WKX_user_bibliography'), 
				array(array('WKX_collection.id' => 'id'), "collectionTitle", "collectionTitleShort", "collectionType"));
			$join = " LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatField("WKX_collection.id") . "=" . 
				$this->db->formatField("collection");
			$sql .= $join;
		}
		else
			$sql = $this->db->selectNoExecute(array("WKX_collection"), 
			array("id", "collectionType", "collectionTitle", "collectionTitleShort"));
		if(isset($condition))
			$condition = " WHERE " . join(" AND ", $condition);
		else
			$condition = FALSE;
		$sql .= $condition . ' GROUP BY ' . $this->db->tidyInputClause('WKX_collection.id') . 
		" ORDER BY " . $this->db->tidyInputClause("collectionTitle");
		$recordset = $this->db->query($sql);
		while($row = $this->db->loopRecordSet($recordset))
		{
			$short = $row['collectionTitleShort'] ? 
				" [" . $row['collectionTitleShort'] . ']' : FALSE;
			$title = $this->html->stripBBCode($row['collectionTitle'] . $short);
			if(!$type)
				$thisType = $row['collectionType'];
			$collections[$row['id']] = $this->html->dbToFormTidy($title);
		}
		if(isset($collections))
		{
// (re)create cache
			$this->db->writeCache('resourceCollections', $collections);
			return $collections;
		}
		return FALSE;
	}
// Get collection names from WKX_collection.  Return associative array of id => collection.  Only return collections for resources in which there is metadata.
	function grabMeta()
	{
		if(is_array($collections = $this->db->readCache('metadataCollections')))
				return $collections;
// quotes
		$recordset = $this->db->select(array("WKX_resource", "WKX_resource_quote"), 
		array("WKX_collection.id", "collectionTitle", "collectionTitleShort", "collectionType"), 
			" LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_resource.id") . "=" . 
				$this->db->formatfield("WKX_resource_misc.id") . 
			" LEFT JOIN " . $this->db->formatTable("WKX_collection") . " ON " . 
				$this->db->formatfield("WKX_collection.id") . "=" . 
				$this->db->formatfield("collection") . 
			" WHERE " .  $this->db->formatfield('WKX_resource_quote.resourceId') . 
				" = " . $this->db->formatfield('WKX_resource.id') . 
			" GROUP BY " . $this->db->tidyInputClause('WKX_collection.id') . 
			" ORDER BY " . $this->db->tidyInputClause('collectionTitle'));
		while($row = $this->db->loopRecordSet($recordset))
		{
			if(!$row['id'])
				continue;
			$short = $row['collectionTitleShort'] ? 
				" [" . $row['collectionTitleShort'] . ']' : FALSE;
			$title = $this->html->stripBBCode($row['collectionTitle'] . $short);
			$type = $row['collectionType'];
			$collections[$row['id']] = $this->html->dbToFormTidy($title);
		}
// paraphrases
		$recordset = $this->db->select(array("WKX_resource", "WKX_resource_paraphrase"), 
		array("WKX_collection.id", "collectionTitle", "collectionTitleShort", "collectionType"), 
			" LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_resource.id") . "=" . 
				$this->db->formatfield("WKX_resource_misc.id") . 
			" LEFT JOIN " . $this->db->formatTable("WKX_collection") . " ON " . 
				$this->db->formatfield("WKX_collection.id") . "=" . 
				$this->db->formatfield("collection") . 
			" WHERE " .  $this->db->formatfield('WKX_resource_paraphrase.resourceId') . 
				" = " . $this->db->formatfield('WKX_resource.id') . 
			" GROUP BY " . $this->db->tidyInputClause('WKX_collection.id') . 
			" ORDER BY " . $this->db->tidyInputClause('collectionTitle'));
		while($row = $this->db->loopRecordSet($recordset))
		{
			if(!$row['id'])
				continue;
			$short = $row['collectionTitleShort'] ? 
				" [" . $row['collectionTitleShort'] . ']' : FALSE;
			$title = $this->html->stripBBCode($row['collectionTitle'] . $short);
			$type = $row['collectionType'];
			$collections[$row['id']] = $this->html->dbToFormTidy($title);
		}
// musings
		$recordset = $this->db->select(array("WKX_resource", "WKX_resource_musing"), 
		array("WKX_collection.id", "collectionTitle", "collectionTitleShort", "collectionType"), 
			" LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_resource.id") . "=" . 
				$this->db->formatfield("WKX_resource_misc.id") . 
			" LEFT JOIN " . $this->db->formatTable("WKX_collection") . " ON " . 
				$this->db->formatfield("WKX_collection.id") . "=" . 
				$this->db->formatfield("collection") . 
			" WHERE " .  $this->db->formatfield('WKX_resource_musing.resourceId') . 
				" = " . $this->db->formatfield('WKX_resource.id') . 
			" GROUP BY " . $this->db->tidyInputClause('WKX_collection.id') . 
			" ORDER BY " . $this->db->tidyInputClause('collectionTitle'));
		while($row = $this->db->loopRecordSet($recordset))
		{
			if(!$row['id'])
				continue;
			$type = $row['collectionType'];
			$short = $row['collectionTitleShort'] ? 
				" [" . $row['collectionTitleShort'] . ']' : FALSE;
			$title = $this->html->stripBBCode($row['collectionTitle'] . $short);
			$collections[$row['id']] = $this->html->dbToFormTidy($title);
		}
		if(isset($collections))
		{
			asort($collections);
// (re)create cache
			$this->db->writeCache('metadataCollections', $collections);
			return $collections;
		}
		return FALSE;
	}
// provide a rough display style for display of collections in select box
	function styleCollection($type, $key, $value)
	{
		$extras = '';
		if($key == 'year1')
			return " ($value)";
		if($type == 'book')
		{
			if($key == 'field2')
				$extras .= " ed.$value";
		}
		else if($type == 'journal')
		{
			if($key == 'field1')
				$extras .= " $value";
			else if($key == 'field2')
				$extras .= "($value)";
		}
		else if($type == 'newspaper')
		{
			if($key == 'field2')
				$extras .= " ($value)";
		}
		else if($type == 'proceedings')
		{
			if($key == 'field1')
				$extras .= " $value";
			else if($key == 'field3')
				$extras .= "($value)";
			else if($key == 'field4')
				$extras .= ". $value";
		}
		else if($type == 'web')
		{
			if($key == 'field1')
				$extras .= " $value";
			else if($key == 'field2')
				$extras .= "($value)";
		}
		else if($type == 'thesis')
		{
			if($key == 'field3')
				$extras .= " $value";
			else if($key == 'field4')
				$extras .= "($value)";
			if($key == 'year2')
				return " ($value)";
		}
		return $extras;
	}
// return a SQL condition clause when selecting by collection
// For use in WKX_resource_misc
	function selectCondition($input)
	{
		$condition = '';
		$selectArray = explode(",", $input['collection']);
		foreach($selectArray as $key => $value)
			$conditionArray[] = $this->db->formatfield('collection') . "=" . $this->db->tidyInput($value);
		$condition .= implode(" " . $input['collectionMethod'] . " ", $conditionArray);
		return $condition;
	}
// write to WKX_collection
	function writeCollectionTable($sessionVars, $publisherId, $confPublisherId, $transPublisherId = FALSE)
	{
		if(array_key_exists('collection_id', $sessionVars))
			return $sessionVars['collection_id'];
		$title = $sessionVars['title'] = array_key_exists('collection', $sessionVars) ? 
			$this->html->removeNl($sessionVars['collection']) : FALSE;
		$short = $sessionVars['titleShort'] = array_key_exists('collectionShort', $sessionVars) ? 
			$this->html->removeNl($sessionVars['collectionShort']) : FALSE;
		$resourceType = 
			array_key_exists('type', $sessionVars) ? $sessionVars['type'] : FALSE;
		$type = $sessionVars['collectionType'] = array_key_exists($resourceType, $this->map->collectionTypes) ? 
			$this->map->collectionTypes[$resourceType] : FALSE;
		if(!$title || !$type)
			return FALSE;
		if($publisherId)
			$sessionVars['publisher'] = $publisherId;
		if($confPublisherId)
			$sessionVars['miscField1'] = $confPublisherId;
		else if($transPublisherId)
			$sessionVars['miscField1'] = $transPublisherId;
// Gather other fields
		$collectionStringArray = array();
		$thisCollectionString = $title . $short;
		$matchArray = $this->map->{$type}['match'];
		foreach($matchArray as $key) // order is important
		{
			if(array_key_exists($key, $sessionVars) && $sessionVars[$key])
				$thisCollectionString .= $sessionVars[$key];
		}
		foreach($this->map->{$type}['resource'] as $key => $null)
		{
			if(array_key_exists($key, $sessionVars) && $sessionVars[$key])
				$collectionStringArray[$key] = $sessionVars[$key];
		}
		foreach($this->map->{$type}['resource_misc'] as $key => $null)
		{
			if(array_key_exists($key, $sessionVars) && $sessionVars[$key])
				$collectionStringArray[$key] = $sessionVars[$key];
		}
		foreach($this->map->{$type}['resource_year'] as $key => $null)
		{
			if(array_key_exists($key, $sessionVars) && $sessionVars[$key])
				$collectionStringArray[$key] = $sessionVars[$key];
		}
// Gather creators
		foreach($this->map->{$type}['resource_creator'] as $key => $null)
		{
			if(array_key_exists($key, $sessionVars) && $sessionVars[$key])
				$collectionStringArray[$key] = $sessionVars[$key];
		}
		if(!empty($collectionStringArray))
		{
			$fields[] = 'collectionString';
			$values[] = base64_encode(serialize($collectionStringArray));
		}
		if($id = $this->checkExists($sessionVars))
			return $id;
		$this->db->deleteCache('resourceCollections');
		$this->db->deleteCache('metadataCollections');
// collection not yet in db, so write to db.
		$fields[] = "collectionTitle";
		$values[] = $title;
		if($short)
		{
			$fields[] = "collectionTitleShort";
			$values[] = $short;
		}
		if($type)
		{
			$fields[] = "collectionType";
			$values[] = $type;
		}
		if(!isset($fields))
			return FALSE;
		$this->db->insert('WKX_collection', $fields, $values);
		$id = $this->db->lastAutoId('WKX_collection');
// Add newcollection to list
		$this->dbCollections[$id] = 
			stripslashes($this->utf8->utf8_strtolower($this->utf8->smartUtf8_encode($thisCollectionString)));
		$ids[] = $id;
		return $id;
	}
// check to see if collection title already exists
// Can't check directly in database as initial non-English characters are not matched (e.g. bersetzung)
	function checkExists($sessionVars, $thisCollectionString = FALSE)
	{
		$type = $sessionVars['collectionType'];
		$title = $sessionVars['title'];
		$shortTitle = array_key_exists('titleShort', $sessionVars) ? $sessionVars['titleShort'] : '';
		$matchArray = $this->map->{$type}['match'];
		if(!$thisCollectionString)
		{
			$thisCollectionString = $title . $shortTitle;
			foreach($matchArray as $key)
			{
				if(array_key_exists($key, $sessionVars))
					$thisCollectionString .= $sessionVars[$key];
			}
		}
		if(array_key_exists('collectionId', $sessionVars)) // editing collection
			$recordset = $this->db->select(array('WKX_collection'), 
				array('id', 'collectionTitle', 'collectionTitleShort', 'collectionString'), 
				' WHERE ' . $this->db->formatField('id') . '!=' . 
				$this->db->tidyInput($sessionVars['collectionId']) . 
				' AND ' . $this->db->formatField('collectionType') . '=' . 
				$this->db->tidyInput($type) );
		else // adding collection via new resource
			$recordset = $this->db->select(array('WKX_collection'), 
				array('id', 'collectionTitle', 'collectionTitleShort', 'collectionString'), 
				' WHERE ' . $this->db->formatField('collectionType') . '=' . 
				$this->db->tidyInput($type) );
		while($row = $this->db->loopRecordSet($recordset))
		{
			$dbString = $row['collectionTitle'] . $row['collectionTitleShort'];
			if($row['collectionString'])
			{
				$stringArray = unserialize(base64_decode($row['collectionString']));
				foreach($matchArray as $key)
				{
					if(array_key_exists($key, $stringArray))
						$dbString .= $stringArray[$key];
				}
			}
			$this->dbCollections[$row['id']] = $dbString;
		}
		$this->dbCollections = array_map(array($this, "encodeUTF8"), $this->dbCollections);
		if(($id = array_search($this->utf8->utf8_strtolower(
				$this->utf8->smartUtf8_encode($thisCollectionString)), 
			$this->dbCollections)) !== FALSE)
			return $id;
		return FALSE;
	}
	function encodeUTF8($element)
	{
		return stripslashes($this->utf8->utf8_strtolower($this->utf8->smartUtf8_encode($element)));
	}
// Remove resource-less collection
	function removeHanging($id = FALSE)
	{
		if($id)
		{
			$recordset = $this->db->select(array('WKX_resource_misc'), 
				array('id'), 
				" WHERE " . $this->db->formatField('collection') . " = $id");
			if(!$this->db->numRows($recordset))
				$this->db->delete('WKX_collection', 
					" WHERE " . $this->db->formatField('id') . "=" . $id);
		}
		else
		{
			$recordset = $this->db->select(array('WKX_collection'), array('id'));
			while($row = $this->db->loopRecordSet($recordset))
				$collectionIds[] = $row['id'];
			$recordset = $this->db->select(array('WKX_resource_misc'), array("collection"));
			while($row = $this->db->loopRecordSet($recordset))
			{
				if($row['collection'])
					$miscCollectionIds[] = $row['collection'];
			}
			if(isset($collectionIds))
			{
				$deleteIds = isset($miscCollectionIds) ? 
					array_diff($collectionIds, $miscCollectionIds) : $collectionIds;
				foreach($deleteIds as $id)
					$this->db->delete('WKX_collection', 
						" WHERE " . $this->db->formatField('id') . "=" . $id);
			}
		}
		$this->db->deleteCache('resourceCollections');
		$this->db->deleteCache('metadataCollections');
		$this->db->optimize('WKX_collection');
	}
// display the types of collections:
	function editCollectionChooseType($message = FALSE)
	{
		$this->template->setVar('heading', $this->messages->text("heading", "edit", " (" . 
			$this->messages->text("resources", "collection") . ")"));
		$pString = $message ? $message : FALSE;
		$recordset = $this->db->select(array('WKX_collection'), 'collectionType', 
		' GROUP BY ' . $this->db->formatField('collectionType'));
		if(!$this->db->numRows($recordset))
		{
			$this->template->setVar('body', $this->messages->text("misc", "noCollections"));
			return $this->template->process();
		}
		while($row = $this->db->loopRecordSet($recordset))
		{
			if(!$row['collectionType'])
				continue;
			else	
				$collections[$row['collectionType']] = $this->messages->text("collection", $row['collectionType']);
		}
		$pString .= FORM::formHeader("editCollection");
		$pString .= FORM::selectFBoxValue($this->messages->text("collection", 'chooseType'), 
			"edit_collectionType", $collections, 10);
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		$pString .= MISC::p(FORM::formSubmit("Proceed"), FALSE, "right");
		$pString .= FORM::formEnd();
		$this->template->setVar('body', $pString);
		return $this->template->process();
	}
// display the list of collections:
	function editDisplay($message = FALSE)
	{
		$this->template->setVar('heading', $this->messages->text("heading", "edit", " (" . 
			$this->messages->text("resources", "collection") . ")"));
		$pString = $message ? $message : FALSE;
		$type = array_key_exists('edit_collectionType', $this->vars) ? 
			$type = $this->vars['edit_collectionType'] : FALSE;
		$collections = $this->grabAll($type);
		if(!$collections || !$type)
		{
			$this->template->setVar('body', $this->messages->text("misc", "noCollections"));
			return $this->template->process();
		}
		$pString .= FORM::formHeader("editCollectionSetCreators");
		$pString .= FORM::hidden("edit_collectionType", $type);
		$pString .= FORM::selectFBoxValue(FALSE, "edit_collectionId", $collections, 20, 80);
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		$pString .= MISC::p(FORM::formSubmit("Proceed"), FALSE, "right");
		$pString .= FORM::formEnd();
		$this->template->setVar('body', $pString);
		return $this->template->process();
	}
// display the number of creators for this collection:
	function editCollectionSetCreators($message = FALSE)
	{
		if(!array_key_exists('edit_collectionType', $this->vars) || !$this->vars['edit_collectionType'])
			$this->badInput($this->errors->text("inputError", "missing"), 'editDisplayTitle');
		$type = $this->vars['edit_collectionType'];
		if(empty($this->map->{$type}['resource_creator'])) // no collection creators possible for this type
			return $this->editDisplayTitle();
		if(!array_key_exists('edit_collectionId', $this->vars) || !$this->vars['edit_collectionId'])
			$this->badInput($this->errors->text("inputError", "missing"), 'editDisplayTitle');
		$this->template->setVar('heading', $this->messages->text("heading", "edit", " (" . 
			$this->messages->text("resources", "collection") . ")"));
// Grab existing creators for this collection
		$recordset = $this->db->select(array('WKX_collection'), 'collectionString', 
			' WHERE ' . $this->db->formatField('id') . '=' . 
			$this->db->tidyInput($this->vars['edit_collectionId']));
		if($collectionString = $this->db->fetchOne($recordset))
		{
			foreach(unserialize(base64_decode($collectionString)) as $key => $value)
			{
				if(array_key_exists($key, $this->map->{$type}['resource_creator']) && $value)
					$numCreators[$key] = sizeof(split(',', $value));
			}
		}
		if(!isset($numCreators)) // creators possible but none yet set
			$numCreators = FALSE;
		$pString = $message ? $message : FALSE;
		$pString .= FORM::formHeader("editCollection");
		$pString .= FORM::hidden("edit_collectionId", $this->vars['edit_collectionId']);
		$pString .= FORM::hidden("edit_collectionType", $type);
		$pString .= $this->creatorInput($type, $numCreators);
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		$pString .= MISC::p(FORM::formSubmit("Proceed"), FALSE, "right");
		$pString .= FORM::formEnd();
		$this->template->setVar('body', $pString);
		return $this->template->process();
	}
	function creatorInput($type, $numCreators)
	{
		$pString = $this->messages->text("collection", "numContributorsEdit");
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		foreach($this->map->{$type}['resource_creator'] as $key => $label)
		{
			$inputName = "edit_num_" . $key;
			if(is_array($numCreators) && array_key_exists($key, $numCreators))
			{
				$rangeStart = $numCreators[$key];
				$rangeEnd = $numCreators[$key] + 5;
				$pString .= TABLE::td(FORM::selectedBox($this->messages->text("creators", $label), 
					$inputName, range($rangeStart, $rangeEnd), $numCreators[$key], "6"));
			}
			else
				$pString .= TABLE::td(FORM::textInput($this->messages->text("creators", $label), 
					$inputName, FALSE, 4, 3));
		}
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		return $pString;
	}
// display the editing form:
	function editDisplayTitle($message = FALSE)
	{
		$this->template->setVar('heading', $this->messages->text("heading", "edit", " (" . 
			$this->messages->text("resources", "collection") . ")"));
		$this->checkInput1();
		$sessionVars = $this->fromDbToSession($this->vars['edit_collectionId'], 
			$this->vars['edit_collectionType']);
		$type = $this->vars['edit_collectionType'];
		foreach($this->map->{$type} as $array)
		{
			foreach($array as $key => $null)
				$editFields[] = $key;
		}
		$pString = $message ? $message : FALSE;
		$pString .= FORM::formHeader("editCollection");
		$pString .= FORM::hidden("edit_collectionId", $this->vars['edit_collectionId']);
		$pString .= FORM::hidden("edit_collectionType", $this->vars['edit_collectionType']);
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		$text = array_key_exists("title", $sessionVars) ? $sessionVars["title"] : FALSE;
		$short = array_key_exists("titleShort", $sessionVars) ? $sessionVars["titleShort"] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "collection"), 
			"edit_title", $text, 60, 255) . " " . MISC::span('*', 'required'));
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "collectionShort"), 
			"edit_titleShort", $short, 20, 255));
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		if(isset($editFields))
		{
// Creators first
			if(!empty($this->map->{$type}['resource_creator']))
			{
				include_once("core/creator/CREATOR.php");
				$creator = new CREATOR($this->db);
				$allCreators = $creator->grabAll();
				if($allCreators)
				{
// add 0 => IGNORE to creators array
					$temp[0] = $this->messages->text("misc", "ignore");
					foreach($allCreators as $key => $value)
						$temp[$key] = $value;
					$allCreators = $temp;
					unset($temp);
				}
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				foreach($this->map->{$type}['resource_creator'] as $typeLabel => $label)
				{
					$creatorIds = array();
					$extra = 'edit_num_' . $typeLabel;
					if(!array_key_exists($typeLabel, $sessionVars))
					{
						if(array_key_exists($extra, $this->vars) && $this->vars[$extra])
							$numCreators = $this->vars[$extra];
						else
							continue;
					}
					else
					{
						$creatorIds = split(',', $sessionVars[$typeLabel]);
						$numCreators = sizeof($creatorIds);
						if(array_key_exists($extra, $this->vars) && $this->vars[$extra])
							$numCreators += $this->vars[$extra] - $numCreators;
					}
					$pString .= TABLE::trStart();
					$pString .= TABLE::td(MISC::b($this->messages->text("creators", $label)) . 
						"&nbsp;&nbsp;" . $this->messages->text("hint", "resourceName"), 
						FALSE, FALSE, FALSE, 5);
					$pString .= TABLE::trEnd();
					$pString .= $this->nameForm($allCreators, $creatorIds, $sessionVars, 
						$numCreators, $typeLabel);
					$pString .= TABLE::trEnd();
				}
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
			}
			$pString .= MISC::br() . "&nbsp;" . MISC::br();
// The fields by $type
			if($type == 'book')
			{
// publisher
				include_once("core/publisher/PUBLISHER.php");
				$publisher = new publisher($this->db);
				$this->publishers = $publisher->grabAll();
				if($this->publishers)
				{
// add 0 => IGNORE to publishers array
					$temp[0] = $this->messages->text("misc", "ignore");
					foreach($this->publishers as $key => $value)
						$temp[$key] = $value;
					$this->publishers = $temp;
				}
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->publisherForm('publisher', $sessionVars);
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
// publication years
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("year1", $sessionVars) ? $sessionVars["year1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_year']['year1']), 
					"edit_year1", $input, 10, 255) . 
					MISC::br() . $this->messages->text("hint", "publicationYear"));
				$input = array_key_exists("year2", $sessionVars) ? $sessionVars["year2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_year']['year2']), 
					"edit_year2", $input, 10, 255));
				$input = array_key_exists("year3", $sessionVars) ? $sessionVars["year3"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_year']['year3']), 
					"edit_year3", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
// series + edition +number of volumes
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("field1", $sessionVars) ? $sessionVars["field1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field1']), 
					"edit_field1", $input, 50, 255));
				$input = array_key_exists("field3", $sessionVars) ? $sessionVars["field3"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field3']), 
					"edit_field3", $input, 10, 255));
				$input = array_key_exists("field2", $sessionVars) ? $sessionVars["field2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field2']), 
					"edit_field2", $input, 10, 255));
				$input = array_key_exists("miscField4", $sessionVars) ? $sessionVars["miscField4"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_misc']['miscField4']), 
					"edit_miscField4", $input, 10, 255) . MISC::br() . $this->messages->text("hint", "integer"));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
// translated work details
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->translationForm($sessionVars);
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
			}
			else if($type == 'journal')
			{
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->dateForm('journal', $sessionVars);
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->dateForm('journal', $sessionVars, TRUE);
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("field1", $sessionVars) ? $sessionVars["field1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field1']), 
					"edit_field1", $input, 10, 255));
				$input = array_key_exists("field2", $sessionVars) ? $sessionVars["field2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field2']), 
					"edit_field2", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
			}
			else if($type == 'newspaper')
			{
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("field2", $sessionVars) ? $sessionVars["field2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field2']), 
					"edit_field2", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
			}
			else if($type == 'proceedings')
			{
// publisher
/*				include_once("core/publisher/PUBLISHER.php");
				$publisher = new publisher($this->db);
				$this->publishers = $publisher->grabAll();
// add 0 => IGNORE to publishers array
				$temp[0] = $this->messages->text("misc", "ignore");
				foreach($this->publishers as $key => $value)
					$temp[$key] = $value;
				$this->publishers = $temp;
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->proceedingsForm($sessionVars);
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->dateForm('proceedings', $sessionVars);
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->dateForm('proceedings', $sessionVars, TRUE);
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("year1", $sessionVars) ? $sessionVars["year1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_year']['year1']), 
					"edit_year1", $input, 10, 255) . MISC::br() . $this->messages->text("hint", "year"));
				$input = array_key_exists("field1", $sessionVars) ? $sessionVars["field1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field1']), 
					"edit_field1", $input, 50, 255));
				$input = array_key_exists("field3", $sessionVars) ? $sessionVars["field3"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field3']), 
					"edit_field3", $input, 10, 255));
				$input = array_key_exists("field4", $sessionVars) ? $sessionVars["field4"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field4']), 
					"edit_field4", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
*/			}
/*			else if ($type == 'thesis')
			{
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("year2", $sessionVars) ? $sessionVars["year2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_year']['year2']), 
					"edit_year2", $input, 10, 255) . MISC::br() . $this->messages->text("hint", "year"));
				$input = array_key_exists("field3", $sessionVars) ? $sessionVars["field3"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field3']), 
					"edit_field3", $input, 10, 255));
				$input = array_key_exists("field4", $sessionVars) ? $sessionVars["field4"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field4']), 
					"edit_field4", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
			}
*/			else if($type == 'music')
			{
// publisher
				include_once("core/publisher/PUBLISHER.php");
				$publisher = new publisher($this->db);
				$this->publishers = $publisher->grabAll();
// add 0 => IGNORE to publishers array
				$temp[0] = $this->messages->text("misc", "ignore");
				foreach($this->publishers as $key => $value)
					$temp[$key] = $value;
				$this->publishers = $temp;
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->publisherForm('publisher', $sessionVars, 'music'); // proceedings publisher
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("year1", $sessionVars) ? $sessionVars["year1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_year']['year1']), 
					"edit_year1", $input, 10, 255) . MISC::br() . $this->messages->text("hint", "year"));
				$input = array_key_exists("field2", $sessionVars) ? $sessionVars["field2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field2']), 
					"edit_field2", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
			}
			else if($type == 'web')
			{
// publisher
				include_once("core/publisher/PUBLISHER.php");
				$publisher = new publisher($this->db);
				$this->publishers = $publisher->grabAll();
// add 0 => IGNORE to publishers array
				$temp[0] = $this->messages->text("misc", "ignore");
				foreach($this->publishers as $key => $value)
					$temp[$key] = $value;
				$this->publishers = $temp;
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->publisherForm('publisher', $sessionVars); // proceedings publisher
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
/*				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("year1", $sessionVars) ? $sessionVars["year1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource_year']['year1']), 
					"edit_year1", $input, 10, 255) . MISC::br() . $this->messages->text("hint", "year"));
				$input = array_key_exists("field1", $sessionVars) ? $sessionVars["field1"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field1']), 
					"edit_field1", $input, 10, 255));
				$input = array_key_exists("field2", $sessionVars) ? $sessionVars["field2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field2']), 
					"edit_field2", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
*/			}
			else if($type == 'miscellaneous')
			{
// publisher
				include_once("core/publisher/PUBLISHER.php");
				$publisher = new publisher($this->db);
				$this->publishers = $publisher->grabAll();
// add 0 => IGNORE to publishers array
				$temp[0] = $this->messages->text("misc", "ignore");
				foreach($this->publishers as $key => $value)
					$temp[$key] = $value;
				$this->publishers = $temp;
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$pString .= $this->publisherForm('publisher', $sessionVars); // proceedings publisher
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
				$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
				$pString .= TABLE::trStart();
				$input = array_key_exists("field2", $sessionVars) ? $sessionVars["field2"] : FALSE;
				$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 
					$this->map->{$type}['resource']['field2']), 
					"edit_field2", $input, 10, 255));
				$pString .= TABLE::trEnd();
				$pString .= TABLE::tableEnd();
				$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
				$pString .= MISC::br() . "&nbsp;" . MISC::br();
			}
		}
		$pString .= MISC::p(FORM::formSubmit("Proceed"), FALSE, "right");
		$pString .= FORM::formEnd();
		$this->template->setVar('body', $pString);
		return $this->template->process();
	}
// write to the database
	function edit()
	{
		include_once("core/publisher/PUBLISHER.php");
		$publisher = new PUBLISHER($this->db);
		if($this->session->getVar('editCollectionLock'))
			$this->badInput($this->errors->text("done", "collection"), 'editCollectionChooseType');
		$type = $this->session->getVar('edit_collectionType') ? 
			$this->session->getVar('edit_collectionType') : $this->vars['edit_collectionType'];
		$collectionId = $this->session->getVar('edit_collectionId') ? 
			$this->session->getVar('edit_collectionId') : $this->vars['edit_collectionId'];
// Grab resource ids for this collection
		$recordset = $this->db->select(array('WKX_resource_misc'), 'id', 
			' WHERE ' . $this->db->formatField('collection') . '=' . $this->db->tidyInput($collectionId));
		while($row = $this->db->loopRecordSet($recordset))
		{
			$this->resourceIds[] = $row['id'];
			$condition[] = $this->db->formatField('id') . '=' . $this->db->tidyInput($row['id']);
		}
		$resourceIdCondition = join(' OR ', $condition);
		unset($condition);
		$oldPublisherId = $this->session->getVar('edit_publisher') ? 
			$this->session->getVar('edit_publisher') : FALSE;
		$oldTransPublisherId = $type == 'book' ? $this->session->getVar('edit_miscField1') : FALSE;
		$oldConfPublisherId = $type == 'proceedings' ? $this->session->getVar('edit_miscField1') : FALSE;
		$sessionVars = $this->checkInput2();
		$sessionVars['type'] = array_search($type, $this->map->collectionTypes); // resource type for PUBLISHER.php
		$fields[] = 'collectionTitle';
		$values[] = $sessionVars['title'];
		if(array_key_exists('titleShort', $sessionVars) && trim($sessionVars['titleShort']))
		{
			$fields[] = 'collectionTitleShort';
			$values[] = $sessionVars['titleShort'];
		}
		else
			$nulls[] = 'collectionTitleShort';
		foreach($fields as $field)
			$updateArray[$field] = array_shift($values);
// Write publisher if new
		if(array_key_exists('publisher', $this->map->{$type}['resource_misc']))
		{
// Check if this new ID is already in WKX_collection.collectionString
			$collectionPublisherIds = array();
			if((array_key_exists('publisher', $sessionVars) && ($sessionVars['publisher'] != $oldPublisherId)) 
				|| 
				(($type == 'book') && 
				array_key_exists('miscField1', $sessionVars) && 
				($sessionVars['miscField1'] != $oldTransPublisherId))
				||
				(($type == 'proceedings') && 
				array_key_exists('miscField1', $sessionVars) && 
				($sessionVars['miscField1'] != $oldConfPublisherId))
			)
			{
				$recordset = $this->db->select(array('WKX_collection'), 
					array('collectionString', 'collectionType'), 
					' WHERE ' . $this->db->formatField('id') . '!=' . $this->db->tidyInput($collectionId) . 
					' AND ' . $this->db->formatField('collectionString') . ' IS NOT NULL');
				while($row = $this->db->loopRecordSet($recordset))
				{
					$array = unserialize(base64_decode($row['collectionString']));
					if(array_key_exists('publisher', $array))
						$collectionPublisherIds[] = $array['publisher'];
					if(($row['collectionType'] == 'book') && array_key_exists('miscField1', $array))
						$collectionPublisherIds[] = $array['miscField1'];
					else if(($row['collectionType'] == 'proceedings') && array_key_exists('miscField1', $array))
						$collectionPublisherIds[] = $array['miscField1'];
				}
				array_unique($collectionPublisherIds);
			}
			if(array_key_exists('publisherName', $sessionVars)) // name overrides all
				$sessionVars['publisher'] = $publisher->writePublisherTable($sessionVars);
			else if(array_key_exists('publisher', $sessionVars))
			{
				$sessionVars['publisher_id'] = $sessionVars['publisher'];
				if(array_search($sessionVars['publisher'], $collectionPublisherIds) === FALSE)
					$sessionVars['publisher'] = $publisher->writePublisherTable($sessionVars);
			}
			if($type == 'book')
			{
				if(array_key_exists('transPublisherName', $sessionVars))
					$sessionVars['miscField1'] = $publisher->writeTransPublisherTable($sessionVars, FALSE, TRUE);
				else if(array_key_exists('miscField1', $sessionVars))
				{
					$sessionVars['transPublisher_id'] = $sessionVars['miscField1'];
					if(array_search($sessionVars['transPublisher_id'], $collectionPublisherIds) === FALSE)
						$sessionVars['miscField1'] = $publisher->writeTransPublisherTable($sessionVars);
				}
			}
			else if($type == 'proceedings')
			{
				if(array_key_exists('transPublisherName', $sessionVars))
					$sessionVars['miscField1'] = $publisher->writeTransPublisherTable($sessionVars, FALSE, TRUE);
				else if(array_key_exists('miscField1', $sessionVars))
				{
					$sessionVars['confPublisher_id'] = $sessionVars['miscField1'];
					if(array_search($sessionVars['confPublisher_id'], $collectionPublisherIds) === FALSE)
						$sessionVars['miscField1'] = 
							$publisher->writeTransPublisherTable($sessionVars, FALSE, TRUE);
				}
			}
		}
		include_once("core/creator/CREATOR.php");
		$creator = new creator($this->db);
		$creatorIds = $creator->writeCreatorTable($sessionVars);
		$collectionStringArray = array();
		$tempUpdateArray = $tempNulls = array();
		foreach($this->map->{$type}['resource'] as $key => $null)
		{
			if(!array_key_exists($key, $sessionVars))
			{
				$tempNulls[] = $key;
				continue;
			}
			$collectionStringArray[$key] = $tempUpdateArray[$key] = $sessionVars[$key];
		}
		if(!empty($tempUpdateArray))
			$this->db->update('WKX_resource', $tempUpdateArray, 
				" WHERE " . $resourceIdCondition);
		if(!empty($tempNulls))
			$this->db->updateNull('WKX_resource', $tempNulls, 
				" WHERE " . $resourceIdCondition);
		$tempUpdateArray = $tempNulls = array();
		foreach($this->map->{$type}['resource_misc'] as $key => $null)
		{
			if(!array_key_exists($key, $sessionVars))
			{
				$tempNulls[] = $key;
				continue;
			}
			$collectionStringArray[$key] = $tempUpdateArray[$key] = $sessionVars[$key];
		}
		if(!empty($tempUpdateArray))
			$this->db->update('WKX_resource_misc', $tempUpdateArray, 
				" WHERE " . $resourceIdCondition);
		if(!empty($tempNulls))
			$this->db->updateNull('WKX_resource_misc', $tempNulls, 
				" WHERE " . $resourceIdCondition);
		$tempUpdateArray = $tempNulls = array();
		foreach($this->map->{$type}['resource_year'] as $key => $null)
		{
			if(!array_key_exists($key, $sessionVars))
			{
				$tempNulls[] = $key;
				continue;
			}
			$collectionStringArray[$key] = $tempUpdateArray[$key] = $sessionVars[$key];
		}
		$this->writeResourceYear($tempUpdateArray, $tempNulls, $resourceIdCondition);
		if($creatorIds)
		{
			foreach($this->map->{$type}['resource_creator'] as $key => $null)
			{
				if(!array_key_exists($key, $creatorIds))
					continue;
				$value = join(',', $creatorIds[$key]);
				$collectionStringArray[$key] = $value;
			}
			$this->writeResourceCreatorTable($creatorIds, $resourceIdCondition);
		}
		$collectionExistId = $this->checkExists($sessionVars);
		if($collectionExistId)
			return $this->confirmDuplicate($collectionExistId);
		if(!empty($collectionStringArray))
			$updateArray['collectionString'] = base64_encode(serialize($collectionStringArray));
		else
			$nulls[] = 'collectionString';
		$this->db->update('WKX_collection', $updateArray, 
			"WHERE " . $this->db->formatField('id') . "=" . 
			$this->db->tidyInput($sessionVars['collectionId']));
		if(isset($nulls) && !empty($nulls))
			$this->db->updateNull('WKX_collection', $nulls, 
				" WHERE " . $this->db->formatField('id') . "=" . $sessionVars['collectionId']);
// Remove resource-less and collection-less publishers
		$publisher->removeHanging();
		$creator->removeHanging();
// lock reload
		$this->session->setVar('editCollectionLock', TRUE);
// Clear session
		$this->session->clearArray("edit");
		$this->db->deleteCache('resourceCollections');
		$this->db->deleteCache('metadataCollections');
// send back to editDisplay with success message
		new CLOSE($this->db, $this->editCollectionChooseType($this->success->text("collection")));
	}
// update WKX_resource_year
	function writeResourceYear($tempUpdateArray, $tempNulls, $resourceIdCondition)
	{
		if(!empty($tempUpdateArray))
			$this->db->update('WKX_resource_year', $tempUpdateArray, 
				" WHERE " . $resourceIdCondition);
		if(!empty($tempNulls))
			$this->db->updateNull('WKX_resource_year', $tempNulls, 
				" WHERE " . $resourceIdCondition);
// If row doesn't yet exist, need to insert instead of update
		$recordset = $this->db->select(array('WKX_resource_year'), array('id'), 
			" WHERE " . $resourceIdCondition);
		while($row = $this->db->loopRecordSet($recordset))
			$existingIds[] = $row['id'];
		if(isset($existingIds))
			$insertIds = array_diff($this->resourceIds, $existingIds);
		else // no row yet exists so insert all rows
			$insertIds = $this->resourceIds;
		if(isset($tempUpdateArray) && isset($insertIds))
		{
			foreach($tempUpdateArray as $key => $value)
			{
				$fields[] = $key;
				$values[] = $value;
			}
			if(isset($fields))
			{
				foreach($insertIds as $id)
				{
					$insertFields = $fields;
					$insertValues = $values;
					$insertFields[] = "id";
					$insertValues[] = $id;
					$this->db->insert('WKX_resource_year', $insertFields, $insertValues);
				}
			}
		}
// Remove any rows where all values of yearx are NULL
		$this->db->delete('WKX_resource_year', ' WHERE ' . 
			$this->db->formatField('year1') . ' IS NULL AND ' . 
			$this->db->formatField('year2') . ' IS NULL AND ' . 
			$this->db->formatField('year3') . ' IS NULL AND ' . 
			$this->db->formatField('year4') . ' IS NULL');
		$this->db->optimize("WKX_resource_year");
	}
// update WKX_resource_creator
	function writeResourceCreatorTable($creatorIds, $resourceIdCondition)
	{
		foreach($creatorIds as $type => $idArray)
		{
			$fields[] = $type;
			$values[] = implode(',', $idArray);
		}
		$storeValues = $values;
		$types = array("creator2", "creator3", "creator4", "creator5",);
		if(isset($fields))
		{
			$nulls = array_diff($types, $fields);
			foreach($fields as $field)
				$updateArray[$field] = array_shift($values);
			$this->db->update('WKX_resource_creator', $updateArray, 
				" WHERE " . $resourceIdCondition);
		}
		if(isset($nulls) && !empty($nulls))
			$this->db->updateNull('WKX_resource_creator', $nulls, 
				" WHERE " .  $resourceIdCondition);
// If row doesn't yet exist, need to insert instead of update
		$recordset = $this->db->select(array('WKX_resource_creator'), array('id'), 
			" WHERE " . $resourceIdCondition);
		while($row = $this->db->loopRecordSet($recordset))
			$existingIds[] = $row['id'];
		if(isset($existingIds))
			$insertIds = array_diff($this->resourceIds, $existingIds);
		else // no row yet exists so insert all rows
			$insertIds = $this->resourceIds;
		if(isset($fields) && isset($insertIds))
		{
			foreach($insertIds as $id)
			{
				$insertFields = $fields;
				$insertValues = $storeValues;
				$insertFields[] = "id";
				$insertValues[] = $id;
				$this->db->insert('WKX_resource_creator', $insertFields, $insertValues);
			}
		}
// Remove any rows where all values of creatorx are NULL
		$this->db->delete('WKX_resource_creator', ' WHERE ' . 
			$this->db->formatField('creator1') . ' IS NULL AND ' . 
			$this->db->formatField('creator2') . ' IS NULL AND ' . 
			$this->db->formatField('creator3') . ' IS NULL AND ' . 
			$this->db->formatField('creator4') . ' IS NULL AND ' . 
			$this->db->formatField('creator5') . ' IS NULL'); 
		$this->db->optimize("WKX_resource_creator");
	}
/**
* The new name equals one already in the database. Confirm that this edited one is to be removed and 
* all references to it replaced by the existing one.
*/
	function confirmDuplicate()
	{
		return $this->editDisplayTitle($this->errors->text("warning", "collectionExists"));
	}
// write to the database.
	function editConfirm()
	{
		if($this->session->getVar('editCollectionLock'))
			$this->badInput($this->errors->text("done", "collection"), 'editCollectionChooseType');
		$editId = $this->vars['edit_collectionId'];
		$existId = $this->vars['edit_collectionExistId'];
// Delete old collection
		$this->db->delete("WKX_collection", "WHERE " . $this->db->formatField('id') . "=" . 
			$this->db->tidyInput($editId));
		$this->db->deleteCache('resourceCollections');
		$this->db->deleteCache('metadataCollections');
// Select all resources referencing this old collection and replace reference with existing collection.
		$sql = $this->db->selectNoExecute(array("WKX_resource_misc"), array('id'), 
			" WHERE " . $this->db->formatField('collection') . "=" . $this->db->tidyInput($editId)
			);
		$recordset = $this->db->query($sql);
		while($row = $this->db->loopRecordSet($recordset))
		{
			$this->db->update('WKX_resource_misc', array('collection' => $existId), 
				"WHERE " . $this->db->formatField('id') . "=" . 
				$this->db->tidyInput($row['id']));
		}
// lock reload
		$this->session->setVar('editCollectionLock', TRUE);
// Clear session
		$this->session->clearArray("edit");
// send back to editDisplay with success message
		new CLOSE($this->db, $this->editDisplay($this->success->text("collection")));
	}
// from database to session
	function fromDbToSession($id, $type)
	{
		$recordset = $this->db->select(array('WKX_collection'), 
			array("collectionTitle", "collectionTitleShort", "collectionString"), 
			" WHERE " . $this->db->formatField('id') . "=" . $this->db->tidyInput($id));
		$row = $this->db->fetchRow($recordset);
		$this->session->setVar("edit_title", $this->html->dbToFormTidy($row['collectionTitle']));
		$this->session->setVar("edit_titleShort", $this->html->dbToFormTidy($row['collectionTitleShort']));
		if($row['collectionString'])
		{
			$stringArray = unserialize(base64_decode($row['collectionString']));
			foreach($stringArray as $key => $value)
				$this->session->setVar("edit_$key", $this->html->dbToFormTidy($value));
		}
		return $this->session->getArray("edit");
	}
// Check we have appropriate input
	function checkInput1()
	{
		if(!array_key_exists('edit_collectionId', $this->vars) || !$this->vars['edit_collectionId'])
			$this->badInput($this->errors->text("inputError", "missing"));
		if(!array_key_exists('edit_collectionType', $this->vars) || !$this->vars['edit_collectionType'])
			$this->badInput($this->errors->text("inputError", "missing"));
	}
// Check we have appropriate input
	function checkInput2()
	{
		$this->writeSession();
		if(!array_key_exists('edit_collectionId', $this->vars) || !$this->vars['edit_collectionId'])
			$this->badInput($this->errors->text("inputError", "missing"), 'editDisplayTitle');
		if(!array_key_exists('edit_title', $this->vars) || !$this->vars['edit_title'])
			$this->badInput($this->errors->text("inputError", "missing"), 'editDisplayTitle');
		if(!array_key_exists('edit_collectionType', $this->vars) || !$this->vars['edit_collectionType'])
			$this->badInput($this->errors->text("inputError", "missing"), 'editDisplayTitle');
		$type = $this->session->getVar('edit_collectionType');
		foreach($this->map->{$type}['resource_creator'] as $creatorType => $throwaway)
		{
			$input = array();
			foreach($this->vars as $key => $value)
			{
				$base = "edit_" . $creatorType . "_";
				if(preg_match("/^$base(.*)/", $key, $match))
					$input[$match[1]] = trim($value);
			}
			if(empty($input))
				continue;
// split on "_"
			foreach($input as $key => $value)
			{
				$components = explode("_", $key);
				if($value = trim($value))
					${$creatorType}[$components[0]][$components[1]] = $value;
			}
			if(empty(${$creatorType}))
				continue;
			foreach(${$creatorType} as $key => $value)
			{
				if(array_key_exists('surname', $value) && $value['surname'])
					$this->vars['edit_' . $creatorType . '_' . $key . '_id'] = FALSE;
				else if(!array_key_exists('edit_' . $creatorType . '_' . $key . '_id', $this->vars) 
					|| !$this->vars['edit_' . $creatorType . '_' . $key . '_id'] && 
					!$this->vars['edit_' . $creatorType . '_' . $key . '_surname'])
				{
					$this->vars['edit_' . $creatorType . '_' . $key . '_initials'] = FALSE;
					$this->vars['edit_' . $creatorType . '_' . $key . '_prefix'] = FALSE;
					$this->vars['edit_' . $creatorType . '_' . $key . '_firstname'] = FALSE;
					$this->vars['edit_' . $creatorType . '_' . $key . '_id'] = FALSE;
				}
				else if(array_key_exists('edit_' . $creatorType . '_' . $key . '_id', $this->vars) 
					&& !${$creatorType}[$key]['id'])
					$this->badInput($this->errors->text("inputError", "missing"), 'editDisplayTitle');
// if id remains, we get rid of initials and firstname
				if(array_key_exists('edit_' . $creatorType . '_' . $key . '_id', $this->vars) && 
					$this->vars['edit_' . $creatorType . '_' . $key . '_id'])
				{
					$this->vars['edit_' . $creatorType . '_' . $key . '_initials'] = FALSE;
					$this->vars['edit_' . $creatorType . '_' . $key . '_firstname'] = FALSE;
				}
			}
		}
// Can't have subtitle but not title of original translated work (book, book_chapter and book_article only).
		if(array_key_exists('edit_transSubtitle', $this->vars) && 
			!array_key_exists('edit_transTitle', $this->vars))
			unset($this->vars['edit_transSubtitle']);
		if($type == 'book')
		{
			$this->checkInputPublisher();
			$this->checkInputTransPublisher();
			$this->checkInputNumbers($type, array('resource_misc' => 'miscField4'));
		}
		else if($type == 'web')
			$this->checkInputPublisher();
		else if($type == 'proceedings_article')
		{
			$this->checkInputConfPublisher();
			$this->checkDateRange($type);
		}
		else if($type == 'music')
			$this->checkInputPublisher();
		return $this->triage();
	}
// all is optional but...
	function checkInputPublisher()
	{
// if publisher name or location, remove publisher_id from input vars.
		if(trim($this->vars['edit_publisherName']))
			$this->vars['edit_publisher'] = FALSE;
// If publisherLocation but !publisherName, set publisherLocation to FALSE
		if(isset($this->vars['edit_publisherLocation']) && 
			!trim($this->vars['edit_publisherName']) && trim($this->vars['edit_publisherLocation']))
			$this->vars['edit_publisherLocation'] = FALSE;
	}
// all is optional but...
	function checkInputConfPublisher()
	{
// if publisher name or location, remove publisher_id from input vars.
		if(trim($this->vars['edit_publisherName']))
			$this->vars['edit_miscField1'] = FALSE;
// If publisherLocation but !publisherName, set publisherLocation to FALSE
		if(isset($this->vars['edit_publisherLocation']) && 
			!trim($this->vars['edit_publisherName']) && trim($this->vars['edit_publisherLocation']))
			$this->vars['edit_publisherLocation'] = FALSE;
		if(trim($this->vars['edit_conferenceName']))
			$this->vars['edit_publisher'] = FALSE;
		if(isset($this->vars['edit_conferenceLocation']) && 
			!trim($this->vars['edit_conferenceName']) && trim($this->vars['edit_conferenceLocation']))
			$this->vars['edit_conferenceLocation'] = FALSE;
	}
// all is optional but...
	function checkInputTransPublisher()
	{
// if transPublisher name or location, remove transPublisher_id from input vars.
		if(trim($this->vars['edit_transPublisherName']))
			$this->vars['edit_miscField1'] = FALSE;
// If transPublisherLocation but !transPublisherName, set transPublisherLocation to FALSE
		if(isset($this->vars['edit_transPublisherLocation']) && 
			!trim($this->vars['edit_transPublisherName']) && 
			trim($this->vars['edit_transPublisherLocation']))
			$this->vars['edit_transPublisherLocation'] = FALSE;
	}
// all is optional but...  must be integers
	function checkInputNumbers($type, $array)
	{
		foreach($array as $key => $field)
		{
			if(isset($this->vars["edit_$field"]) && trim($this->vars["edit_$field"])
				&& (!is_numeric(trim($this->vars["edit_$field"])) && 
				(trim($this->vars["edit_$field"]) != $this->messages->text('misc', 'ignore'))))
				$this->badInput($this->errors->text("inputError", "nan", " (" . 
					$this->messages->text("resources", $this->map->{$type}[$key][$field]) . 
					")"), 'editDisplayTitle');
		}
	}
// all is optional but...
	function checkDateRange()
	{
// If no start dates but only end dates, put end dates into start date fields.
		if(array_key_exists('edit_year2', $this->vars) && !trim($this->vars['edit_year2']) && 
			!trim($this->vars['edit_miscField2']) && !trim($this->vars['edit_miscField3']))
		{
			if(trim($this->vars['edit_year3']))
			{
				$this->vars['edit_year2'] = trim($this->vars['edit_year3']);
				$this->session->setVar('edit_year2', trim($this->vars['edit_year3']));
				$this->session->delVar('edit_year3');
			}
			if(trim($this->vars['edit_miscField5']))
			{
				$this->vars['edit_miscField2'] = trim($this->vars['edit_miscField5']);
				$this->session->setVar('edit_miscField2', trim($this->vars['edit_miscField5']));
				$this->session->delVar('edit_miscField5');
			}
			if(trim($this->vars['edit_miscField6']))
			{
				$this->vars['edit_miscField3'] = trim($this->vars['edit_miscField6']);
				$this->session->setVar('edit_miscField3', trim($this->vars['edit_miscField6']));
				$this->session->delVar('edit_miscField6');
			}
		}
	}
// Remove empty values from $this->vars.
// Additionally, remove any previous session variable of that name if the input is empty or FALSE
	function triage()
	{
		$allInput = $this->vars;
		foreach($allInput as $key => $value)
		{
			if(!is_array($value) && !trim($value))
			{
				unset($this->vars[$key]);
				$this->session->delVar($key);
			}
		}
		$sessionVars = $temp = $this->session->getArray('edit');
		if(!isset($sessionVars) || !$sessionVars)
			$sessionVars = array();
		return $sessionVars;
	}
// return link to other resources having this resource's collection or just the plain collection if no other resources found.
	function getCollectionLink($resourceId, $cId, $collection)
	{
		$sql = $this->db->selectNoExecute(
			array("WKX_resource"), array(array("WKX_resource.id" => "resourceId")), 
			" LEFT JOIN " . 
				$this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatField("WKX_resource.id") . "=" . 
				$this->db->formatField("WKX_resource_misc.id") .  
			" WHERE " . $this->db->formatField('collection') . '=' . $this->db->tidyInput($cId)
			);
// If we are browsing a user bibliography, we return only results from this bibliography
		if($useBib = $this->session->getVar("mywikindx_bibliography_use"))
		{
			if($this->userBibCategories($sql, $resourceId, $useBib))
				return MISC::a("link", $collection, "index.php?action=listCollectionProcess" . 
					htmlentities("&id=" . $cId));
			else
				return $collection;
		}
// Results from the Master Bibliography
		$masterSql = $sql . " AND (" . $this->db->formatField('WKX_resource.id') . " != " . 
			$this->db->tidyInput($resourceId) . ")";
		$recordset = $this->db->query($masterSql);
		while($line = $this->db->loopRecordSet($recordset))
			$masterCollectionResources[] = $line['resourceId'];
		if(isset($masterCollectionResources))
			return MISC::a("link", $collection, "index.php?action=listCollectionProcess" . 
				htmlentities("&id=" . $cId));
		else
			return $collection;
	}
// Scan user bibliography for collection
	function userBibCategories($sql, $resourceId, $useBib)
	{
		$recordset = $this->db->select(array('WKX_user_bibliography'), array('bibliography'), 
			" WHERE " . $this->db->formatfield('id') . "=" . $this->db->tidyInput($useBib));
		$dbBibs = $this->db->fetchOne($recordset);
		$bibsArray = explode(",", $dbBibs);
		$bibCondition = "(" . $this->db->formatfield('WKX_resource.id') . " = ";
		foreach($bibsArray as $id)
		{
			if($id == $resourceId)
				continue;
			$conditionArray[] = $this->db->tidyInput($id);
		}
		if(!isset($conditionArray))
			return FALSE;
		$bibCondition .= implode(" OR " . $this->db->formatfield('WKX_resource.id') . " = ", 
			$conditionArray) . ")";
		$sql .= " AND " . $bibCondition;
		$recordset = $this->db->query($sql);
		while($line = $this->db->loopRecordSet($recordset))
			$bibCategoryResources[] = $line['resourceId'];
		if(isset($bibCategoryResources))
			return $bibCategoryResources;
	}
// Publisher form
	function publisherForm($publisherIdField, $sessionVars, $collectionType = FALSE)
	{
		$hint = $this->publishers ? $this->messages->text("hint", "publisherName") : FALSE;
		if($collectionType == 'music')
			$title = $this->messages->text("resources", "recordLabel");
		else
			$title = $this->messages->text("resources", "publisher");
		$pString = MISC::p(MISC::b($title) . "&nbsp;&nbsp;" . $hint);
		$input = array_key_exists('publisherName', $sessionVars) ? $sessionVars['publisherName'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'publisherName'), 
			"edit_publisherName", $input, 40, 255));
		if(!$collectionType)
		{
			$input = array_key_exists('publisherLocation', $sessionVars) ? 
				$sessionVars['publisherLocation'] : FALSE;
			$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'publisherLocation'), 
				"edit_publisherLocation", $input, 30, 255));
		}
		if($this->publishers)
		{
			if(array_key_exists($publisherIdField, $sessionVars))
				$pString .= TABLE::td(FORM::selectedBoxValue(FALSE, "edit_$publisherIdField", 
				$this->publishers, $sessionVars[$publisherIdField], "6"));
			else
				$pString .= TABLE::td(FORM::selectFBoxValue(FALSE, "edit_$publisherIdField", 
				$this->publishers, "6"));
		}
		return $pString;
	}
// Proceedings form -- has publisher and conferenceorganizer
	function proceedingsForm($sessionVars)
	{
		$hint = !empty($this->publishers) ? $this->messages->text("hint", "publisherName") : FALSE;
// publisher first (in WKX_resource_misc.miscField1)
		$title = $this->messages->text("resources", "publisher");
		$pString = MISC::p(MISC::b($title) . "&nbsp;&nbsp;" . $hint);
		$input = array_key_exists('publisherName', $sessionVars) ? $sessionVars['publisherName'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'publisherName'), 
			"edit_publisherName", $input, 40, 255));
		$input = array_key_exists('publisherLocation', $sessionVars) ? 
			$sessionVars['publisherLocation'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'publisherLocation'), 
			"edit_publisherLocation", $input, 30, 255));
		if($this->publishers)
		{
			if(array_key_exists('miscField1', $sessionVars))
				$pString .= TABLE::td(FORM::selectedBoxValue(FALSE, "edit_miscField1", 
				$this->publishers, $sessionVars['miscField1'], "6"));
			else
				$pString .= TABLE::td(FORM::selectFBoxValue(FALSE, "edit_miscField1", 
				$this->publishers, "6"));
		}
// conference organizer (in WKX_resource_misc.publisher)
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		$title = $this->messages->text("resources", "conference");
		$pString .= MISC::p(MISC::b($title) . "&nbsp;&nbsp;" . $hint);
		$input = array_key_exists('conferenceName', $sessionVars) ? $sessionVars['conferenceName'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'conferenceOrganiser'), 
			"edit_conferenceName", $input, 40, 255));
		$input = array_key_exists('conferenceLocation', $sessionVars) ? 
			$sessionVars['conferenceLocation'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'conferenceLocation'), 
			"edit_conferenceLocation", $input, 30, 255));
		if($this->publishers)
		{
			if(array_key_exists('publisher', $sessionVars))
				$pString .= TABLE::td(FORM::selectedBoxValue(FALSE, "edit_publisher", 
				$this->publishers, $sessionVars['publisher'], "6"));
			else
				$pString .= TABLE::td(FORM::selectFBoxValue(FALSE, "edit_publisher", 
				$this->publishers, "6"));
		}
		return $pString;
	}
// Translated work form
	function translationForm($sessionVars)
	{
		$hint = $this->publishers ? $this->messages->text("hint", "publisherName") : FALSE;
		$title = $this->messages->text("resources", "translatedFrom");
		$pString = MISC::p(MISC::b($title) . "&nbsp;&nbsp;" . $hint);
		$input = array_key_exists('transPublisherName', $sessionVars) ? 
			$sessionVars['transPublisherName'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'publisher'), 
			"edit_transPublisherName", $input, 40, 255));
		$input = array_key_exists('transPublisherLocation', $sessionVars) ? 
			$sessionVars['transPublisherLocation'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'publisherLocation'), 
			"edit_transPublisherLocation", $input, 30, 255));
		if($this->publishers)
		{
			if(array_key_exists("miscField1", $sessionVars))
				$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("resources", "publisher"), 
					"edit_miscField1", $this->publishers, $sessionVars["miscField1"], "6"));
			else
				$pString .= TABLE::td(FORM::selectFBoxValue($this->messages->text("resources", "publisher"),
					"edit_miscField1", $this->publishers, "6"));
		}
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		if(array_key_exists("transTitle", $sessionVars) && $sessionVars['transTitle'] == '(no title)')
			unset($sessionVars['transTitle']);
		$title = array_key_exists("transTitle", $sessionVars) ? 
			$this->html->dbToFormTidy($sessionVars['transTitle']) : FALSE;
		$subtitle = array_key_exists("transSubtitle", $sessionVars) ? 
			$this->html->dbToFormTidy($sessionVars['transSubtitle']) : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "title"), 
			"edit_transTitle", $title, 50) . MISC::br() . 
			FORM::textInput($this->messages->text("resources", "subtitle"), "edit_transSubtitle", 
			$subtitle, 50) . MISC::br() . $this->messages->text("hint", "capitals"));
		$input = array_key_exists('year4', $sessionVars) ? $sessionVars['year4'] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", 'publicationYear'), 
			"edit_year4", $input, 10, 255) . MISC::br() . $this->messages->text("hint", "publicationYear"));
		return $pString;
	}
// create form for inputting names
	function nameForm($creators, $creatorIds, $sessionVars, $num, $type)
	{
		$pString = '';
		for($index = 1; $index <= $num; $index++)
		{
			$creatorId = array_shift($creatorIds);
			$pString .= TABLE::trStart();
			$subEntry = $type . "_" . $index . "_firstname";
			$entry = "edit_" . $subEntry;
			$id = $type . "_" . $index . "_id";
			$idLabel = 'edit_' . $id;
			$text = array_key_exists($subEntry, $sessionVars) ? $sessionVars[$subEntry] : FALSE;
			$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "firstname"), 
				$entry, $this->html->dbToFormTidy($text), 30, 255));
			$subEntry = $type . "_" . $index . "_initials";
			$entry = "edit_" . $subEntry;
			$text = array_key_exists($subEntry, $sessionVars) ? $sessionVars[$subEntry] : FALSE;
			$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "initials"), 
				$entry, $this->html->dbToFormTidy($text), 6, 255) . 
				MISC::br() . $this->messages->text("hint", "initials"));
			$subEntry = $type . "_" . $index . "_prefix";
			$entry = "edit_" . $subEntry;
			$text = array_key_exists($subEntry, $sessionVars) ? $sessionVars[$subEntry] : FALSE;
			$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "prefix"), 
				$entry, $this->html->dbToFormTidy($text), 11, 10));
			$subEntry = $type . "_" . $index . "_surname";
			$entry = "edit_" . $subEntry;
			$text = array_key_exists($subEntry, $sessionVars) ? $sessionVars[$subEntry] : FALSE;
			$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "surname"), 
				$entry, $this->html->dbToFormTidy($text), 30, 255) . " " . MISC::span('*', 'required'));
			if($creators)
			{
				if(array_key_exists($creatorId, $creators))
					$pString .= TABLE::td(FORM::selectedBoxValue(FALSE, $idLabel, 
					$creators, $creatorId, "6"));
				else
					$pString .= TABLE::td(FORM::selectFBoxValue(FALSE, $idLabel, $creators, "6"));
			}
			$pString .= TABLE::trEnd();
		}
		return $pString;
	}
// form input for date (day/month/year) - miscField2, miscField3 and yearx fields.
// If $endDate, this is end date so handles miscField5, miscField6 and year3
	function dateForm($type, $sessionVars, $endDate = FALSE)
	{
		if(!$endDate)
		{
			$dayField = "miscField2";
			$monthField = "miscField3";
			$yearField = "year1";
		}
		else
		{
			$dayField = "miscField5";
			$monthField = "miscField6";
			$yearField = "year3";
		}
// Load month arrays
		include_once("core/messages/CONSTANTS.php");
		$constant = new CONSTANTS();
		$pString = '';
		$days[] = $this->messages->text("misc", "ignore");
		$days = array_merge($days, range(1, 31));
		$months[] = $this->messages->text("misc", "ignore");
		$months = array_merge($months, $constant->constants->monthToLongName());
		$dayText = $monthText = 0;// 'IGNORE'
		if(array_key_exists($dayField, $sessionVars) && $sessionVars[$dayField])
			$dayText = $sessionVars[$dayField];
		if(array_key_exists($monthField, $sessionVars) && $sessionVars[$monthField])
			$monthText = $sessionVars[$monthField];
		if(!isset($sessionVars[$yearField]) || !$sessionVars[$yearField])
			$sessionVars[$yearField] = FALSE;
		$required = $end = $day = '';
		if($type == 'proceedings')
		{
			if(!$endDate)
				$yearField = "year2";
			if($endDate)
				$day = MISC::b($this->messages->text("resources", "conferenceDate") . 
					" (" . $this->messages->text("resources", "dateEnd") . ")") . MISC::br();
			else
				$day = MISC::b($this->messages->text("resources", "conferenceDate") . 
					" (" . $this->messages->text("resources", "dateStart") . ")") . MISC::br();
			$required = '';
		}
		else if(($type == 'journal') && $endDate)
		{
			$end = MISC::b(" (" . $this->messages->text("resources", "dateEnd") . ")") . MISC::br();
			$required = '';
		}
		if($type == 'proceedings')
			$pString .= TABLE::td(FORM::selectedBoxValue($day . $this->messages->text("resources", "day"),
			"edit_$dayField", $days, $dayText, "6") . $required);
		$pString .= TABLE::td(FORM::selectedBoxValue($end . $this->messages->text("resources", "month"), 
			"edit_$monthField", $months, $monthText, "6") . $required);
		$text = array_key_exists($yearField, $sessionVars) ? $sessionVars[$yearField] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "year"), 
			"edit_$yearField", $this->html->dbToFormTidy($text), 31, 30) . 
			$required . MISC::br() . $this->messages->text("hint", "year"));
		return $pString;
	}
// Error handling - send them back to view creator list.
	function badInput($error, $method = 'editDisplay')
	{
		new CLOSE($this->db, $this->$method($error));
	}
// write input to session
	function writeSession()
	{
// Write all input with 'edit_' prefix to session
		foreach($this->vars as $key => $value)
		{
			if(preg_match("/^edit_/", $key))
				$temp[$key] = trim($value);
		}
		if(isset($temp))
			$this->session->writeArray($temp);
		return $this->session->getArray('edit');
	}
}
?>
