<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2007
sirfragalot@users.sourceforge.net
**********************************************************************************/
/*****
*	Publisher class.
*
*	$Header: /cvsroot/wikindx/wikindx3/core/publisher/PUBLISHER.php,v 1.25 2007/04/12 11:49:37 sirfragalot Exp $
*****/
class PUBLISHER
{
// Constructor
	function PUBLISHER($db, $vars = FALSE)
	{
		$this->db = $db;
		$this->vars = $vars;
		include_once("core/session/SESSION.php");
		$this->session = new SESSION();
		include_once("core/html/HTML.php");
		$this->html = new HTML();
		include_once("core/messages/MESSAGES.php");
		$this->messages = new MESSAGES();
		include_once("core/messages/SUCCESS.php");
		$this->success = new SUCCESS();
		include_once("core/messages/ERRORS.php");
		$this->errors = new ERRORS();
		include_once("core/publisher/PUBLISHERMAP.php");
		$this->map = new PUBLISHERMAP();
		include_once("core/html/MISC.php");
		include_once("core/html/FORM.php");
		include_once("core/template/TEMPLATE.php");
		$this->template = new TEMPLATE('content');
		include_once("core/html/CLOSE.php");
		include_once("core/messages/UTF8.php");
		$this->utf8 = new UTF8();
		$this->dbPublishers = array();
	}
// Get publishers from WKX_publisher.  Return associative array of id => type
	function grabAll($type = FALSE, $userBib = FALSE)
	{
		if(!$userBib && !$type && is_array($publishers = $this->db->readCache('resourcePublishers')))
				return $publishers;
		if($type)
			$condition[] = " (" . $this->db->formatField('publisherType') . "=" . 
			$this->db->tidyInput($this->map->publisherTypes[$type]) . 
			" OR " . $this->db->formatField('publisherType') . "IS NULL)";
		if($userBib)
		{
/*			$recordset = $this->db->select(array('WKX_user_bibliography'), array('bibliography'), 
				" WHERE " . $this->db->formatfield('id') . "=" . $this->db->tidyInput($userBib));
			$dbBibs = $this->db->fetchOne($recordset);
			$bibsArray = explode(",", $dbBibs);
			foreach($bibsArray as $resourceId)
				$bibConditionArray[] = $this->db->tidyInput($resourceId);
			$condition[] = " (WKX_resource_misc.id = " . 
				implode(" OR WKX_resource_misc.id = ", $bibConditionArray) . ")";
*/
			$condition[] = " FIND_IN_SET(" . $this->db->formatField('WKX_resource_misc.id') . 
				", CONCAT(" . $this->db->formatField('WKX_user_bibliography.bibliography') . 
				", ','))";
			$condition[] = $this->db->formatField('WKX_user_bibliography.id') . "=" . 
				$this->db->tidyInput($userBib);
			$sql = $this->db->selectNoExecute(array('WKX_publisher', 'WKX_user_bibliography'), 
				array(array('WKX_publisher.id' => 'id'), "publisherName", "publisherLocation"));
			$join = " LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_publisher.id") . "=" . $this->db->formatfield("publisher");
			$sql .= $join;
		}
		else
			$sql = $this->db->selectNoExecute(array("WKX_publisher"), 
			array("id", "publisherName", "publisherLocation"));
		if(isset($condition))
			$condition = " WHERE " . join(" AND ", $condition);
		else
			$condition = FALSE;
		$sql .= $condition . ' GROUP BY ' . $this->db->tidyInputClause('WKX_publisher.id') . 
			" ORDER BY " . $this->db->tidyInputClause("publisherName");
		$recordset = $this->db->query($sql);
		while($row = $this->db->loopRecordSet($recordset))
		{
			if($row['publisherLocation'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName'] . 
				": " . $row['publisherLocation']);
			else
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName']);
		}
		if(isset($publishers))
		{
// (re)create cache
			$this->db->writeCache('resourcePublishers', $publishers);
			return $publishers;
		}
		return FALSE;
	}
// Get publisher names from WKX_publisher.  Return associative array of id => publisher.  Only return publishers for resources in which there is metadata.
	function grabMeta()
	{
		if(is_array($publishers = $this->db->readCache('metadataPublishers')))
				return $publishers;
// quotes
		$recordset = $this->db->select(array("WKX_resource", "WKX_resource_quote"), 
		array("WKX_publisher.id", "publisherName", "publisherLocation"), 
			" LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_resource.id") . "=" . 
				$this->db->formatfield("WKX_resource_misc.id") . 
			" LEFT JOIN " . $this->db->formatTable("WKX_publisher") . " ON " . 
				$this->db->formatfield("WKX_publisher.id") . "=" . 
				$this->db->formatfield("publisher") . 
			" WHERE " .  $this->db->formatfield('WKX_resource_quote.resourceId') . 
				" = " . $this->db->formatfield('WKX_resource.id') . 
			" GROUP BY " . $this->db->tidyInputClause('WKX_publisher.id') . 
			" ORDER BY " . $this->db->tidyInputClause('publisherName'));
		while($row = $this->db->loopRecordSet($recordset))
		{
			if($row['publisherLocation'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName'] . 
				": " . $row['publisherLocation']);
			else if($row['publisherName'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName']);
		}
// paraphrases
		$recordset = $this->db->select(array("WKX_resource", "WKX_resource_paraphrase"), 
		array("WKX_publisher.id", "publisherName", "publisherLocation"), 
			" LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_resource.id") . "=" . 
				$this->db->formatfield("WKX_resource_misc.id") . 
			" LEFT JOIN " . $this->db->formatTable("WKX_publisher") . " ON " . 
				$this->db->formatfield("WKX_publisher.id") . "=" . 
				$this->db->formatfield("publisher") . 
			" WHERE " .  $this->db->formatfield('WKX_resource_paraphrase.resourceId') . 
				" = " . $this->db->formatfield('WKX_resource.id') . 
			" GROUP BY " . $this->db->tidyInputClause('WKX_publisher.id') . 
			" ORDER BY " . $this->db->tidyInputClause('publisherName'));
		while($row = $this->db->loopRecordSet($recordset))
		{
			if($row['publisherLocation'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName'] . 
				": " . $row['publisherLocation']);
			else if($row['publisherName'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName']);
		}
// musings
		$recordset = $this->db->select(array("WKX_resource", "WKX_resource_musing"), 
		array("WKX_publisher.id", "publisherName", "publisherLocation"), 
			" LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_resource.id") . "=" . 
				$this->db->formatfield("WKX_resource_misc.id") . 
			" LEFT JOIN " . $this->db->formatTable("WKX_publisher") . " ON " . 
				$this->db->formatfield("WKX_publisher.id") . "=" . 
				$this->db->formatfield("publisher") . 
			" WHERE " .  $this->db->formatfield('WKX_resource_musing.resourceId') . 
				" = " . $this->db->formatfield('WKX_resource.id') . 
			" GROUP BY " . $this->db->tidyInputClause('WKX_publisher.id') . 
			" ORDER BY " . $this->db->tidyInputClause('publisherName'));
		while($row = $this->db->loopRecordSet($recordset))
		{
			if($row['publisherLocation'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName'] . 
				": " . $row['publisherLocation']);
			else if($row['publisherName'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName']);
		}
		if(isset($publishers))
		{
			asort($publishers);
// (re)create cache
			$this->db->writeCache('metadataPublishers', $publishers);
			return $publishers;
		}
		return FALSE;
	}
// Get conference organisers from WKX_publisher.  Return associative array of id => type
	function grabAllConfOrganisers($userBib = FALSE)
	{
		if(!$userBib && is_array($publishers = $this->db->readCache('conferenceOrganisers')))
				return $publishers;
		$condition[] = " (" . $this->db->formatField('publisherType') . "=" . 
			$this->db->tidyInput('conference') . 
			" AND " . $this->db->formatField('WKX_resource_misc.publisher') . "=" . 
			$this->db->formatField('WKX_publisher.id') . ")";
		if($userBib)
		{
/*			$recordset = $this->db->select(array('WKX_user_bibliography'), array('bibliography'), 
				" WHERE " . $this->db->formatfield('id') . "=" . $this->db->tidyInput($userBib));
			$dbBibs = $this->db->fetchOne($recordset);
			$bibsArray = explode(",", $dbBibs);
			foreach($bibsArray as $resourceId)
				$bibConditionArray[] = $this->db->tidyInput($resourceId);
			$condition[] = " (WKX_resource_misc.id = " . 
				implode(" OR WKX_resource_misc.id = ", $bibConditionArray) . ")";
*/
			$condition[] = " FIND_IN_SET(" . $this->db->formatField('WKX_resource_misc.id') . 
				", CONCAT(" . $this->db->formatField('WKX_user_bibliography.bibliography') . 
				", ','))";
			$condition[] = $this->db->formatField('WKX_user_bibliography.id') . "=" . 
				$this->db->tidyInput($userBib);
			$sql = $this->db->selectNoExecute(array('WKX_publisher', 'WKX_user_bibliography'), 
				array(array('WKX_publisher.id' => 'id'), "publisherName", "publisherLocation"));
			$join = " LEFT JOIN " . $this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatfield("WKX_publisher.id") . "=" . $this->db->formatfield("publisher");
			$sql .= $join;
		}
		else
			$sql = $this->db->selectNoExecute(array("WKX_publisher", "WKX_resource_misc"), 
			array(array('WKX_publisher.id' => 'id'), "publisherName", "publisherLocation"));
		if(isset($condition))
			$condition = " WHERE " . join(" AND ", $condition);
		else
			$condition = FALSE;
		$sql .= $condition .  ' GROUP BY ' . $this->db->tidyInputClause('WKX_publisher.id') . 
			" ORDER BY " . $this->db->tidyInputClause("publisherName");
		$recordset = $this->db->query($sql);
		while($row = $this->db->loopRecordSet($recordset))
		{
			if($row['publisherLocation'])
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName'] . 
				": " . $row['publisherLocation']);
			else
				$publishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName']);
		}
		if(isset($publishers))
		{
// (re)create cache
			$this->db->writeCache('conferenceOrganisers', $publishers);
			return $publishers;
		}
		return FALSE;
	}
// return a SQL condition clause when selecting by publisher
	function selectCondition($input)
	{
		$condition = '';
		$selectArray = explode(",", $input['publisher']);
		foreach($selectArray as $key => $value)
//			$conditionArray[] = $this->db->formatfield('publisher') . "=" . $this->db->tidyInput($value);
			$conditionArray[] = " IF(" . 
				$this->db->formatField('type') . '=' . $this->db->tidyInput('proceedings_article') . 
				' OR ' . $this->db->formatField('type') . '=' . $this->db->tidyInput('proceedings') . 
				' OR ' . $this->db->formatField('type') . '=' . $this->db->tidyInput('book') . 
				' OR ' . $this->db->formatField('type') . '=' . $this->db->tidyInput('book_article') . 
				',' . 
				$this->db->formatField('miscField1') . '=' . $this->db->tidyInput($value) . 
				' OR ' . $this->db->formatField('publisher') . '=' . $this->db->tidyInput($value) . 
				',' . 
				$this->db->formatField('publisher') . '=' . $this->db->tidyInput($value) . ')';
		$condition .= implode(" " . $input['publisherMethod'] . " ", $conditionArray);
		return $condition;
	}
// write to WKX_publisher
	function writePublisherTable($sessionVars, $id = FALSE, $confPublisher = FALSE)
	{
		$type = $sessionVars['type'];
		if(array_key_exists('publisher_id', $sessionVars) && !$confPublisher)
		{
// If $type == 'miscellaneous', we set `publisherType` to NULL so that this publisher is available in all lists
			if(($type == 'miscellaneous') || ($type == 'miscellaneous_section'))
				$this->db->updateNull('WKX_publisher', array('publisherType'), 
					" WHERE " . $this->db->formatField('id') . "=" . 
					$this->db->tidyInput($sessionVars['publisher_id']));
			return $sessionVars['publisher_id'];
		}
		if(array_key_exists('confPublisher_id', $sessionVars) && $confPublisher)
		{
// If $type == 'miscellaneous', we set `publisherType` to NULL so that this publisher is available in all lists
			if(($type == 'miscellaneous') || ($type == 'miscellaneous_section'))
				$this->db->updateNull('WKX_publisher', array('publisherType'), 
					" WHERE " . $this->db->formatField('id') . "=" . 
					$this->db->tidyInput($sessionVars['confPublisher_id']));
			return $sessionVars['confPublisher_id'];
		}
		if($confPublisher) // publisher for conferences
		{
			$name = array_key_exists('confPublisherName', $sessionVars) ? 
				$this->html->removeNl($sessionVars['confPublisherName']) : FALSE;
			$location = array_key_exists('confPublisherLocation', $sessionVars) ? 
				$this->html->removeNl($sessionVars['confPublisherLocation']) : FALSE;
		}
		else
		{
			$name = array_key_exists('publisherName', $sessionVars) ? 
				$this->html->removeNl($sessionVars['publisherName']) : FALSE;
			$location = array_key_exists('publisherLocation', $sessionVars) ? 
				$this->html->removeNl($sessionVars['publisherLocation']) : FALSE;
		}
		$publisherType = array_key_exists($type, $this->map->publisherTypes) ? 
			$this->map->publisherTypes[$type] : FALSE;
		if(!$name && !$location)
			return FALSE;
// If publisher type in database does not match this resource type, set publisherType to NULL so publisher
// is available in all lists.
		list($id, $publisherTypeDB) = $this->checkExists($name, $location);
		$this->db->deleteCache('resourcePublishers');
		$this->db->deleteCache('metadataPublishers');
		$this->db->deleteCache('conferenceOrganisers');
//		if($id && $publisherTypeDB)
		if($id)
		{
			if(($type == 'miscellaneous') || ($type == 'miscellaneous_section') || 
			($publisherType != $publisherTypeDB))
				$this->db->updateNull('WKX_publisher', array('publisherType'), 
					" WHERE " . $this->db->formatField('id') . "=" . $this->db->tidyInput($id));
			return $id;
		}
// publisher not yet in db, so write to db.
		if($name)
		{
			$fields[] = "publisherName";
			$values[] = $name;
		}
		if($location)
		{
			$fields[] = "publisherLocation";
			$values[] = $location;
		}
		if($publisherType)
		{
			$fields[] = "publisherType";
			$values[] = $publisherType;
		}
		if(!isset($fields))
			return FALSE;
		$this->db->insert('WKX_publisher', $fields, $values);
		$id = $this->db->lastAutoId('WKX_publisher');
// Add new publisher to list
		$this->dbPublishers[$id] = 
			$this->utf8->utf8_strtolower($this->utf8->smartUtf8_encode($name . $location));
		$ids[] = $id;
		return $id;
	}
// write to WKX_publisher for translated works original publisher details
	function writeTransPublisherTable($sessionVars)
	{
		if(array_key_exists('transPublisher_id', $sessionVars))
			return $sessionVars['transPublisher_id'];
		$name = array_key_exists('transPublisherName', $sessionVars) ? 
			$this->html->removeNl($sessionVars['transPublisherName']) : FALSE;
		$location = array_key_exists('transPublisherLocation', $sessionVars) ? 
			$this->html->removeNl($sessionVars['transPublisherLocation']) : FALSE;
		$type = $sessionVars['type'];
		$publisherType = array_key_exists($type, $this->map->publisherTypes) ? 
			$this->map->publisherTypes[$type] : FALSE;
		if(!$name && !$location)
			return FALSE;
// If publisher type in database does not match this resource type, set publisherType to NULL so publisher
// is available in all lists.
		list($id, $publisherTypeDB) = $this->checkExists($name, $location);
		$this->db->deleteCache('resourcePublishers');
		$this->db->deleteCache('metadataPublishers');
		$this->db->deleteCache('conferenceOrganisers');
//		if($id && $publisherTypeDB)
		if($id)
		{
			if($publisherType != $publisherTypeDB)
				$this->db->updateNull('WKX_publisher', array('publisherType'), 
					" WHERE " . $this->db->formatField('id') . "=" . $this->db->tidyInput($id));
			return $id;
		}
// publisher not yet in db, so write to db.
		if($name)
		{
			$fields[] = "publisherName";
			$values[] = $name;
		}
		if($location)
		{
			$fields[] = "publisherLocation";
			$values[] = $location;
		}
		if($publisherType)
		{
			$fields[] = "publisherType";
			$values[] = $publisherType;
		}
		if(!isset($fields))
			return FALSE;
		$this->db->insert('WKX_publisher', $fields, $values);
		$id = $this->db->lastAutoId('WKX_publisher');
// Add new publisher to list
		$this->dbPublishers[$id] = 
			$this->utf8->utf8_strtolower($this->utf8->smartUtf8_encode($name . $location));
		$ids[] = $id;
		return $id;
	}
// check to see if publisher name: location already exists
// Can't check directly in database as initial non-English characters are not matched (e.g. bersetzung)
	function checkExists($name, $location)
	{
		$recordset = $this->db->select(array('WKX_publisher'), array('id', 'publisherType', 
			'publisherName', 'publisherLocation'));
		while($row = $this->db->loopRecordSet($recordset))
		{
			$this->dbPublishers[$row['id']] = $this->html->dbToFormTidy($row['publisherName']) . 
				$this->html->dbToFormTidy($row['publisherLocation']);
			$publisherType = $row['publisherType'];
		}
		$this->dbPublishers = array_map(array($this, "encodeUTF8"), $this->dbPublishers);
		$publisher = $name . $location;
		if(($id = array_search($this->utf8->utf8_strtolower($this->utf8->smartUtf8_encode($publisher)), 
			$this->dbPublishers)) !== FALSE)
			return array($id, $publisherType);
		return array(FALSE, FALSE);
	}
	function encodeUTF8($element)
	{
		return $this->utf8->utf8_strtolower($this->utf8->smartUtf8_encode($element));
	}
// Remove resource-less or collection-less publishers
	function removeHanging()
	{
		$recordset = $this->db->select(array('WKX_publisher'), array('id'));
		if(!$this->db->numRows($recordset)) // nothing to delete
			return;
		while($row = $this->db->loopRecordSet($recordset))
			$publisherIds[] = $row['id'];
// Grab all references to publisher IDs
		$existingPublisherIds = array();
		$recordset = $this->db->select(array('WKX_resource_misc'), array('publisher'), 
			" WHERE " . $this->db->formatField('publisher') . ' IS NOT NULL');
		while($row = $this->db->loopRecordSet($recordset))
			$existingPublisherIds[] = $row['publisher'];
		$recordset = $this->db->select(array('WKX_resource_misc'), array('miscField1'), 
			' LEFT JOIN ' . 
				$this->db->formatTable('WKX_resource') . 
				' ON ' . 
				$this->db->formatField('WKX_resource.id') . '=' . 
				$this->db->formatField('WKX_resource_misc.id') . 
			" WHERE (" . $this->db->formatField('type') .'=' . $this->db->tidyInput('book') . 
				' OR '  . $this->db->formatField('type') .'=' . 
				$this->db->tidyInput('proceedings_article') .  
				' OR '  . $this->db->formatField('type') .'=' . 
				$this->db->tidyInput('proceedings') .  
			") AND " . $this->db->formatField('miscField1') . ' IS NOT NULL'
			);
		while($row = $this->db->loopRecordSet($recordset))
			$existingPublisherIds[] = $row['miscField1'];
		$recordset = $this->db->select(array('WKX_collection'), array('collectionString', 'collectionType'), 
			" WHERE " . $this->db->formatField('collectionString') . ' IS NOT NULL');
		while($row = $this->db->loopRecordSet($recordset))
		{
			$array = unserialize(base64_decode($row['collectionString']));
			if(array_key_exists('publisher', $array))
				$existingPublisherIds[] = $array['publisher'];
			if((($row['collectionType'] == 'book') || ($row['collectionType'] == 'proceedings')) && 
				array_key_exists('miscField1', $array))
				$existingPublisherIds[] = $array['miscField1'];
		}
		$existingPublisherIds = array_unique($existingPublisherIds);
		if(empty($existingPublisherIds)) // no publishers being used any more so delete all
		{
			$this->db->delete('WKX_publisher');
			$this->db->optimize('WKX_publisher');
			$this->db->deleteCache('resourcePublishers');
			$this->db->deleteCache('metadataPublishers');
			$this->db->deleteCache('conferenceOrganisers');
			return;
		}
		$deleteIds = array_diff($publisherIds, $existingPublisherIds);
		if(empty($deleteIds))
			return; // nothing to do
		foreach($deleteIds as $id)
			$conditions[] = $this->db->formatField('id') . "=" . $this->db->tidyInput($id);
		$condition = ' WHERE ' . join(' OR ', $conditions);
		$this->db->delete('WKX_publisher', $condition);
		$this->db->optimize('WKX_publisher');
		$this->db->deleteCache('resourcePublishers');
		$this->db->deleteCache('metadataPublishers');
		$this->db->deleteCache('conferenceOrganisers');
	}
// display the list of publishers:
	function editDisplay($message = FALSE)
	{
		$this->template->setVar('heading', $this->messages->text("heading", "edit", " (" . 
			$this->messages->text("resources", "publisher") . ")"));
		$pString = $message ? $message : FALSE;
		$creators = $this->grabAll();
		if(!$creators)
		{
			$this->template->setVar('body', $this->messages->text("misc", "noPublishers"));
			return $this->template->process();
		}
		$pString .= FORM::formHeader("editPublisher");
		$pString .= FORM::selectFBoxValue(FALSE, "edit_publisherId", $creators, 20);
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		$pString .= MISC::p(FORM::formSubmit("Proceed"), FALSE, "right");
		$pString .= FORM::formEnd();
		$this->template->setVar('body', $pString);
		return $this->template->process();
	}
// display the editing form:
	function editDisplayPublisher()
	{
		$this->template->setVar('heading', $this->messages->text("heading", "edit", " (" . 
			$this->messages->text("resources", "publisher") . ")"));
		$this->checkInput1();
		$sessionVars = $this->fromDbToSession($this->vars['edit_publisherId']);
		$pString = FORM::formHeader("editPublisher");
		$pString .= FORM::hidden("edit_publisherId", $this->vars['edit_publisherId']);
		$pString .= TABLE::tableStart(FALSE, 0, 0, 0, "left");
		$pString .= TABLE::trStart();
		$text = array_key_exists("publisher", $sessionVars) ? $sessionVars["publisher"] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "publisher"), 
			"edit_publisher", $text, 30, 255) . " " . MISC::span('*', 'required'));
		$text = array_key_exists("location", $sessionVars) ? $sessionVars["location"] : FALSE;
		$pString .= TABLE::td(FORM::textInput($this->messages->text("resources", "publisherLocation"), 
			"edit_location", $text, 30, 255));
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= TABLE::tdEnd() . TABLE::trEnd() . TABLE::trStart() . TABLE::tdStart();
		$pString .= MISC::p(FORM::formSubmit("Proceed"), FALSE, "right");
		$pString .= FORM::formEnd();
		$this->template->setVar('body', $pString);
		return $this->template->process();
	}
// write to the database
	function edit()
	{
		if($this->session->getVar('editPublisherLock'))
			$this->badInput($this->errors->text("done", "publisher"));
		$this->checkInput2();
		$fields[] = 'publisherName';
		$values[] = $this->vars['edit_publisher'];
		if(trim($this->vars['edit_location']))
		{
			$fields[] = 'publisherLocation';
			$values[] = $this->vars['edit_location'];
		}
		else
			$nulls[] = 'publisherLocation';
		foreach($fields as $field)
			$updateArray[$field] = array_shift($values);
		list($publisherExistId, $null) = $this->checkExists(trim($this->vars['edit_publisher']), 
			trim($this->vars['edit_location']));
		if($publisherExistId)
		{
			if($publisherExistId != $this->vars['edit_publisherId'])
				return $this->confirmDuplicate($publisherExistId, $this->vars['edit_publisher'], 
					$this->vars['edit_location']);
		}
		$this->db->update('WKX_publisher', $updateArray, 
			"WHERE " . $this->db->formatField('id') . "=" . 
			$this->db->tidyInput($this->vars['edit_publisherId']));
// set to NULL empty location field
		if(isset($nulls) && !empty($nulls))
			$this->db->updateNull('WKX_publisher', $nulls, 
				" WHERE " . $this->db->formatField('id') . "=" . 
				$this->db->tidyInput($this->vars['edit_publisherId']));
// lock reload
		$this->session->setVar('editPublisherLock', TRUE);
// Clear session
		$this->session->clearArray("edit");
		$this->db->deleteCache('resourcePublishers');
		$this->db->deleteCache('metadataPublishers');
		$this->db->deleteCache('conferenceOrganisers');
// send back to editDisplay with success message
		new CLOSE($this->db, $this->editDisplay($this->success->text("publisher")));
	}
/**
* The new name equals one already in the database. Confirm that this edited one is to be removed and 
* all references to it replaced by the existing one.
*/
	function confirmDuplicate($publisherExistId, $name, $location)
	{
		$this->template->setVar('heading', $this->messages->text("heading", "edit", " (" . 
			$this->messages->text("resources", "publisher") . ")"));
		$pString = $this->errors->text("warning", "publisherExists");
		$pString .= MISC::p($this->messages->text("misc", "publisherExists"));
		$pString .= FORM::formHeader("editPublisherConfirm");
		$pString .= FORM::hidden("edit_publisherId", $this->vars['edit_publisherId']);
		$pString .= FORM::hidden("edit_publisherExistId", $publisherExistId);
		$pString .= MISC::p(FORM::formSubmit("Proceed"), FALSE, "right");
		$pString .= FORM::formEnd();
		$this->template->setVar('body', $pString);
		return $this->template->process();
	}
// write to the database.
	function editConfirm()
	{
		if($this->session->getVar('editPublisherLock'))
			$this->badInput($this->errors->text("done", "publisher"));
		$editId = $this->vars['edit_publisherId'];
		$existId = $this->vars['edit_publisherExistId'];
// Delete old publisher
		$this->db->delete("WKX_publisher", "WHERE " . $this->db->formatField('id') . "=" . 
			$this->db->tidyInput($editId));
		$this->db->deleteCache('resourcePublishers');
		$this->db->deleteCache('metadataPublishers');
		$this->db->deleteCache('conferenceOrganisers');
// Select all resources referencing this old publisher and replace reference with existing publisher.
// NB - proceedings_article has two publishers - publisher + conf. organiser
		$sql = $this->db->selectNoExecute(array("WKX_resource_misc"), 
			array(array("WKX_resource.id" => 'resourceId'), 'type'), 
			" LEFT JOIN " . $this->db->formatTable('WKX_resource') . " ON " . 
			$this->db->formatField('WKX_resource.id') . "=" . 
			$this->db->formatField('WKX_resource_misc.id') .
			" WHERE " . $this->db->formatField('publisher') . "=" . $this->db->tidyInput($editId) . 
			" OR " . 
			"(" . $this->db->formatfield('type') . "=" . $this->db->tidyInput('proceedings_article') . 
			" AND " . $this->db->formatField('miscField1') . "=" . $this->db->tidyInput($editId) . 
			")"
			);
		$recordset = $this->db->query($sql);
		while($row = $this->db->loopRecordSet($recordset))
		{
			if($row['type'] == 'proceedings_article')
				$this->db->update('WKX_resource_misc', array('miscField1' => $existId), 
						"WHERE " . $this->db->formatField('id') . "=" . 
						$this->db->tidyInput($row['resourceId']));
			else
				$this->db->update('WKX_resource_misc', array('publisher' => $existId), 
						"WHERE " . $this->db->formatField('id') . "=" . 
						$this->db->tidyInput($row['resourceId']));
		}
// lock reload
		$this->session->setVar('editPublisherLock', TRUE);
// Clear session
		$this->session->clearArray("edit");
// send back to editDisplay with success message
		new CLOSE($this->db, $this->editDisplay($this->success->text("publisher")));
	}
// from database to session
	function fromDbToSession($id)
	{
		$recordset = $this->db->select(array('WKX_publisher'), array("publisherName", "publisherLocation"), 
			" WHERE " . $this->db->formatField('id') . "=" . $this->db->tidyInput($id));
		$row = $this->db->fetchRow($recordset);
		if($row['publisherLocation'])
			$this->session->setVar("edit_location", $this->html->dbToFormTidy($row['publisherLocation']));
		$this->session->setVar("edit_publisher", $this->html->dbToFormTidy($row['publisherName']));
		return $this->session->getArray("edit");
	}
// Check we have appropriate input
	function checkInput1()
	{
		if(!array_key_exists('edit_publisherId', $this->vars) || !$this->vars['edit_publisherId'])
			$this->badInput($this->errors->text("inputError", "missing"));
	}
// Check we have appropriate input
	function checkInput2()
	{
		if(!array_key_exists('edit_publisherId', $this->vars) || !$this->vars['edit_publisherId'])
			$this->badInput($this->errors->text("inputError", "missing"));
		if(!array_key_exists('edit_publisher', $this->vars) || !trim($this->vars['edit_publisher']))
			$this->badInput($this->errors->text("inputError", "missing"));
	}
// return link to other resources having this resource's publisher or just the plain publisher if no other resources found.
	function getPublisherLink($resourceId, $pId, $publisher)
	{
		$sql = $this->db->selectNoExecute(
			array("WKX_resource"), array(array("WKX_resource.id" => "resourceId")), 
			" LEFT JOIN " . 
				$this->db->formatTable("WKX_resource_misc") . " ON " . 
				$this->db->formatField("WKX_resource.id") . "=" . 
				$this->db->formatField("WKX_resource_misc.id") .  
			" WHERE " . $this->db->formatField('publisher') . '=' . $this->db->tidyInput($pId)
			);
// If we are browsing a user bibliography, we return only results from this bibliography
		if($useBib = $this->session->getVar("mywikindx_bibliography_use"))
		{
			if($this->userBibCategories($sql, $resourceId, $useBib))
				return MISC::a("link", $publisher, "index.php?action=listPublisherProcess" . 
					htmlentities("&id=" . $pId));
			else
				return $publisher;
		}
// Results from the Master Bibliography
		$masterSql = $sql . " AND (" . $this->db->formatField('WKX_resource.id') . " != " . 
			$this->db->tidyInput($resourceId) . ")";
		$recordset = $this->db->query($masterSql);
		while($line = $this->db->loopRecordSet($recordset))
			$masterPublisherResources[] = $line['resourceId'];
		if(isset($masterPublisherResources))
			return MISC::a("link", $publisher, "index.php?action=listPublisherProcess" . 
				htmlentities("&id=" . $pId));
		else
			return $publisher;
	}
// Scan user bibliography for publisher
	function userBibCategories($sql, $resourceId, $useBib)
	{
		$recordset = $this->db->select(array('WKX_user_bibliography'), array('bibliography'), 
			" WHERE " . $this->db->formatfield('id') . "=" . $this->db->tidyInput($useBib));
		$dbBibs = $this->db->fetchOne($recordset);
		$bibsArray = explode(",", $dbBibs);
		$bibCondition = "(" . $this->db->formatfield('WKX_resource.id') . " = ";
		foreach($bibsArray as $id)
		{
			if($id == $resourceId)
				continue;
			$conditionArray[] = $this->db->tidyInput($id);
		}
		if(!isset($conditionArray))
			return FALSE;
		$bibCondition .= implode(" OR " . $this->db->formatfield('WKX_resource.id') . " = ", 
			$conditionArray) . ")";
		$sql .= " AND " . $bibCondition;
		$recordset = $this->db->query($sql);
		while($line = $this->db->loopRecordSet($recordset))
			$bibCategoryResources[] = $line['resourceId'];
		if(isset($bibCategoryResources))
			return $bibCategoryResources;
	}
// Error handling - send them back to view creator list.
	function badInput($error)
	{
		new CLOSE($this->db, $this->editDisplay($error));
	}
}
?>
