<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2007
sirfragalot@users.sourceforge.net
**********************************************************************************/
/*****
* USINGWIKINDX ENGLISH class
*
* NOTE TO TRANSLATORS:  1/  Both the class name and the constructor name should be changed to match the (case-sensitive) name of 
*				the folder your language files are in.  For example, if you are supplying a Klingon translation and 
*				your languages/ folder is languages/kn/, the class and constructor name for the file SUCCESS.php 
*				must both be SUCCESS_kn.
*
* NOTE TO DEVELOPERS:  1/ Any comments not preceeded by '//' will be ignored by the localization module.
*				2/  All comments and all define statements should each be on one line (no line breaks) and must each start at 
*					the beginning of the line for the localization module to work.
*				3/  The define constant must be in double quotes:  e.g. define("TEXT1", .......);
*****/
class USINGWIKINDX_en
{
// Constructor
	function USINGWIKINDX_en()
	{
// START__LOCALIZATION__MODULE__COPY
////////////////////////////////////////////////////////////////////////////////////
// TRANSLATORS start here.  Translate ONLY the second string in each define().  Don't translate anything that looks like HTML tags <...>
// START__LOCALIZATION__MODULE__DEFINES
/*
GENERAL TERMINOLOGY
*/
define("T_HEADING", "Terms used in WIKINDX");
define("T_RESOURCE", "<strong>Resource:</strong> A resource is the basic unit in Wikindx and is a body of work which can be referenced. It may be a complete book, an article in a book or a journal article etc. and is therefore analagous to a single entry in a bibliography. A resource can have multiple file attachments, one abstract, one general note and multiple <em>metadata</em>.  It belongs to one or more <em>categories</em> and can be referenced by zero <em>keywords</em> or by multiple keywords.  All resources belong to the Wikindx master <em>bibliography</em> and can be added or, once added, edited by anyone with write access to the Wikindx (administrators may modify this default behaviour by allowing only the originator to edit the resource -- all other write-enabled users may still add metadata.). Only WIKINDX administrators can delete a resource and doing so will remove all metadata that is part of that resource.");
define("T_CATEGORY", "<strong>Category:</strong> A category is intended to be the top level categorization of the Wikindx.  The 'General' category always exists and the Wikindx administrators can add more allowing the building up of a Wikindx that covers several subject areas or disciplines.  A resource must belong to at least one category.  The Wikindx user can display resources by category or search for a term only from resources belonging to a category. All categories can be browsed displaying the results as a tag cloud with an indication of the number of resources referenced by each category.");
define("T_KEYWORD", "<strong>Keyword:</strong> A keyword is intended to be the second level of finer categorization.  A resource can have zero or more keywords referring to it and any user with write access to the Wikindx can create or edit keywords.  Additionally, a resource's metadata can be referenced by keywords which are drawn from the same keyword list as used by resources. All keywords can be browsed displaying the results as a tag cloud with an indication of the number of resources referenced by each keyword.");
define("T_METADATA", "<strong>Metadata:</strong> Metadata is the collective term used for quotes, paraphrases, musings and comments referring to a resource and there is no limit to the number of metadata any resource may have. All Wikindx users with write access can add metadata to any resource but only the original submitter and Wikindx administrators can edit and delete metadata (with one exception).  Quotes and paraphrases added to the resource may each have comments (which cannot be edited by anyone other than the comment submitter) from each Wikindx user but only one comment per user per quote or paraphrase. Additionally, each resource may likewise have musings, one from each Wikindx user and musings, with comments, can be set to be publicly viewable by all Wikindx users or to be private and viewable only by that user.  All quotes, paraphrases and musings can be referenced by keywords and all metadata is selectable and searchable by a variety of parameters.  Users can insert metadata directly into the <em>SUWP</em> so it is a good idea to enter metadata in a readily usable (by the SUWP) form.");
define("T_BIBLIOGRAPHY", "<strong>Bibliography:</strong> A Wikindx consists of one master bibliography consisting of all the resources and metadata in the Wikindx.  This bibliography can be added to by anyone with write access to the Wikindx.  Additionally, each such user may have unlimited user bibliographies which are references to resources in the master bibliography.  Removing a resource from a user bibliography will not delete it from the master bibliography; deleting a resource from the master bibliography will remove it from all user bibliographies.  Wikindx users can choose to browse a user bibliography rather than the master bibliography in which case all search and select operations are performed solely on the resources in that user bibliography.  Any metadata added to a resource in a user bibliography is actually added to the resource in the master bibliography as a user bibliography is simply a list of references to resources in the master bibliography.");
define("T_CREATOR", "<strong>Creator</strong> A creator is a synonym for a contributor to a resource whether that be an author, editor, translator, performer, artist, producer etc.  Resources and metadata can be selected and searched through by creator surnames.  Additionally, all creator surnames can be browsed displaying the results as a tag cloud with an indication of the number of resources attributed to each creator.");
define("T_COLLECTION", "<strong>Collection</strong> A collection is the generic name given to any publication of which a resource may be a part of.  For example, a resource of the type journal article is a part of a journal and a music track is a part of a music album.  In these cases, the journal and music album are referred to as collections and resources can be selected and searched through by collection. All collections can be browsed displaying the results as a tag cloud with an indication of the number of resources belonging to each collection.");
define("T_COLLECTION2", "Collections are created and deleted automatically.  When entering a new resource which is part of a collection, that collection is created automatically according to the entered details.  If collections exist already for such a resource type, the user may choose to add the resource to an existing collection.  Collections are automatically deleted when WIKINDX detects that all resources belonging to that collection have been deleted.  Existing collection details may be edited through the Edit menu.");
/*
SINGLE USER WORD PROCESSOR
*/
define("SUWP_HEADING", "Single User Word Processor");
// Don't translate SUWP or WYSIWYG (unless there's an equivalent for What You See Is What You Get)
define("SUWP_1", "The Single User Word Processor [SUWP] is a WYSIWYG word processor available to all Wikindx users with write access.  With it, a user can write a complete article entirely within Wikindx before exporting it to Rich Text Format [RTF] for any final polishing in an external word processor.");
define("SUWP_2", "A variety of formatting options are provided including but not limited to fonts, font colours and sizes, bold, italics, underline, paragraph alignment and indentation and superscripting and subscripting of text.  URLs, images, timestamps and special characters may be inserted and there is unlimited undo and redo.");
define("SUWP_3", "The most powerful feature of the SUWP though, is the ability to insert metadata from the Wikindx directly into the article (automatically appended with the correct citation code and page numbers if required).  Upon exporting to RTF, the user  can choose which bibliographic style to use (APA or Harvard for example) and all citation codes will be converted to the correct bibliographic/citation style with a list of references used in the article appended.  The SUWP is able to handle bibliographic/citation styles requiring in-text citations, footnote citations or endnote citations.");
define("SUWP_4", "Additionally, Wikindx can format in-text citations for those bibliographic/citation styles (such as APA) that require the citation year to follow the creator(s) surname and the page number to follow the quote if the creator(s) surname is in the same sentence as the quote.  This, and other such conditional citation formatting, is defined within each bibliographic/citation style file which can be created and edited by Wikindx administrators.");
// Don't translate [cite]
define("SUWP_5", "To allow for greater accuracy when reformatting an article for different bibliographic/citation styles, ensure that the citation codes are as inserted automatically following the quote or paraphrase. WIKINDX expects there to be a single space before the initial [cite] tag -- if this is not here, you may get unexpected results.");
define("SUWP_6", "You can insert footnotes into the body of the text.  If the bibliographic/citation style is in-text (for example APA style), these will be displayed as footnotes at the bottom of each page of the RTF export. For bibliographic/citation styles that use footnotes or endnotes for their citations, these footnotes will be either footnotes or endnotes depending on the style. You may get unexpected results if you nest footnotes or insert citation tags into footnotes.");
// Perhaps change "double quotes" to whatever your language uses to indicate a quotation.
define ("SUWP_7", "When exporting a paper and choosing to indent quotes larger than a certain number of words you should be careful about the use of quotation markers (such as double quotes for instance).  WIKINDX detects a quote by looking for the start quotation marker and an end quotation marker before the first occurrence of a [cite] tag.  The following will be treated as one quotation to be indented:");
define("SUWP_8", "\"It is an idiom suited to an atmosphere of \"pomp and display\". In style, the \"music of the cinema\", by and large, represents a fixation at a stage of development which the art itself left behind about thirty years ago. Tschaikovsky, Rachmaninov, Sibelius, are the spiritual fathers of most cinema music\" [cite]250[/cite].");
define("SUWP_9", "If a quotation is not an actual citation, it is better to indicate this some other way than by using the quotation markers used for citations otherwise you may get unexpected indentations.");
/*
MISCELLANEOUS TIPS
*/
define("MISC_HEADING", "Miscellaneous advice");
define("MISC_1", "When viewing a single resource, the creators of the resource and collection, publisher, categories and keywords the resource belongs to are displayed underneath.  These will be hyperlinked if other resources have the same creators or belong to the same collection, publisher, categories and keywords allowing the user to quickly browse other related resources.  Additionally, if other resources cite that resource from their abstract, notes or metadata, a hyperlink to browse those other resources is also provided.  The option to cite a resource from within another is available when editing the abstract, notes or metadata.");
define("MISC_2", "When a resource is deleted, all collection, publisher, creator and keyword details are deleted too if they are no longer in use by other resources.");
define("MISC_3", "As a registered user, if you explicitly logout or select the 'Save State' item from the Wikindx menu, a number of session variables will be stored in the database including last list view, last solo view, bookmarks, basket, export options, and list options. These will be restored when logging on again or when automatically logging onto WIKINDX using a cookie. In the latter case, the restored session refers to the last time you explicitly logged out.");
/*
RESOURCE AND METADATA TIPS
*/
define("R_HEADING", "Adding and Editing Resources and Metadata");
define("R_1", "The following assumes a write-enabled user.");
define("R_2", "To add a new resource, go to the <em>Resources</em> menu and choose 'New'.  You need to first choose the type of resource (such as book, journal article or web site) and then enter the title and, if required, a subtitle and short title.  The next page prompts you to enter the number and type of creators the resource has.  Depending on the type of resource you selected, the available creator types will be different.  The final page is for the entry of other details of the resource and, as with creator types, this will be different depending upon the type of resource you selected.  When entering details for creators and publishers, you may select a pre-existing item from the select boxes or type in the data in the text boxes.  If you type something that already exists, WIKINDX recognizes this and proceeds seamlessly without duplication.  The final page is also where the abstract, general note, category(s) and keyword(s) for the resource may be entered.");
define("R_3", "If you are the WIKINDX administrator, multiple resources may be entered by importing bibTeX or Endnote XML files from the <em>Admin</em> menu.  If the Administrator has enabled it, write-enabled users may also copy and paste bibTeX files from the <em>Resources</em> menu.");
define("R_4", "To edit a resource's details, you must first display that resource.  Find the resource by using one of the list, select, search or browse options from the <em>Resources</em> menu then click on the edit icon to the side of the appropriate resource.  This displays a series of pages similar to those used when entering a new resource.");
define("R_5", "To add metadata and attachments to a resource you must first display that resource.  Find the resource by using one of the list, select, search or browse options from the <em>Resources</em> menu then click on the view icon to the side of the appropriate resource.  This displays the resource details, attachments and metadata and provides the opportunity to add attachments (this must be enabled by the administrator and only those that created this resource may add an attachment) and add or edit metadata.  Metadata may be classified with keywords which can then be browsed from the <em>Metadata</em> menu.");
// END__LOCALIZATION__MODULE__DEFINES
// TRANSLATORS end here
////////////////////////////////////////////////////////////////////////////////////
// END__LOCALIZATION__MODULE__COPY

		include_once("core/html/MISC.php");
		include_once("core/messages/MESSAGES.php");
		$this->messages = new MESSAGES();
// Start the templating system
		include_once("core/template/TEMPLATE.php");
		$this->template = new TEMPLATE('content');
	}
// Main display function
	function display()
	{
		include_once("core/messages/UTF8.php");
		$utf8 = new UTF8();
		$top = MISC::a("link", $utf8->decodeUtf8($this->messages->text("misc", "top")), "#top");
		$this->template->setVar('heading', $utf8->decodeUtf8($this->messages->text("heading", "usingWikindx")));
		$this->internalAnchors();
		$this->terms();
		$this->pString .= MISC::p(MISC::hr());
		$this->pString .= MISC::p($top, "small", "right");
		$this->resources();
		$this->pString .= MISC::p(MISC::hr());
		$this->pString .= MISC::p($top, "small", "right");
		$this->suwp();
		$this->pString .= MISC::p(MISC::hr());
		$this->pString .= MISC::p($top, "small", "right");
		$this->misc();
		$this->pString .= MISC::p(MISC::hr());
		$this->pString .= MISC::p($top, "small", "right");
		$this->template->setVar('body', $this->pString);
		return $this->template->process();
	}
// explanation of terms used
	function terms()
	{
		$this->pString .= MISC::aName("terms") . MISC::b(T_HEADING) . ":";
		$this->pString .= MISC::p(T_RESOURCE);
		$this->pString .= MISC::p(T_CATEGORY);
		$this->pString .= MISC::p(T_KEYWORD);
		$this->pString .= MISC::p(T_METADATA);
		$this->pString .= MISC::p(T_BIBLIOGRAPHY);
		$this->pString .= MISC::p(T_CREATOR);
		$this->pString .= MISC::p(T_COLLECTION);
		$this->pString .= MISC::p(T_COLLECTION2);
	}
// explanation of resources and metadata
	function resources()
	{
		$this->pString .= MISC::aName("resources") . MISC::b(R_HEADING) . ":";
		$this->pString .= MISC::p(R_1);
		$this->pString .= MISC::p(R_2);
		$this->pString .= MISC::p(R_3);
		$this->pString .= MISC::p(R_4);
		$this->pString .= MISC::p(R_5);
	}
// explanation of the SUWP
	function suwp()
	{
		$this->pString .= MISC::aName("suwp") . MISC::b(SUWP_HEADING) . ":";
		$this->pString .= MISC::p(SUWP_1);
		$this->pString .= MISC::p(SUWP_2);
		$this->pString .= MISC::p(SUWP_3);
		$this->pString .= MISC::p(SUWP_4);
		$this->pString .= MISC::p(SUWP_5);
		$this->pString .= MISC::p(SUWP_6);
		$this->pString .= MISC::p(SUWP_7);
		$this->pString .= MISC::p(SUWP_8);
		$this->pString .= MISC::p(SUWP_9);
	}
// miscellaneous tips
	function misc()
	{
		$this->pString .= MISC::aName("misc") . MISC::b(MISC_HEADING) . ":";
		$this->pString .= MISC::p(MISC_1);
		$this->pString .= MISC::p(MISC_2);
		$this->pString .= MISC::p(MISC_3);
	}
// print internal anchors
	function internalanchors()
	{
		$this->pString = MISC::aName("top");
		$this->pString .= MISC::a("link", T_HEADING, "#terms") . MISC::br();
		$this->pString .= MISC::a("link", R_HEADING, "#resources") . MISC::br();
		$this->pString .= MISC::a("link", SUWP_HEADING, "#suwp") . MISC::br();
		$this->pString .= MISC::a("link", MISC_HEADING, "#misc") . MISC::br();
		$this->pString .= MISC::p(MISC::hr());
	}
}
?>